/*
 * Copyright (c) 2013-2018 QuartzDesk.com. All Rights Reserved.
 * QuartzDesk.com PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

/**
 * Extension of the standard RowExpander plugin that offers collapse-all and expand-all functionality.
 */
Ext.define( "Ext.ux.grid.EnhancedRowExpander", {
  alias : "plugin.EnhancedRowExpander",
  extend : "Ext.grid.plugin.RowExpander",

  isCollapsed : function ( rowIdx )
  {
    var me = this;
    var rowNode = me.view.getNode( rowIdx );
    var row = Ext.fly( rowNode, '_rowExpander' );

    return row.hasCls( me.rowCollapsedCls )
  },


  collapse : function ( rowIdx )
  {
    if ( !this.isCollapsed( rowIdx ) )
    {
      this.toggleRow( rowIdx, this.grid.getStore().getAt( rowIdx ) );
    }
  },


  collapseAll : function ()
  {
    for ( i = 0; i < this.grid.getStore().getTotalCount(); i++ )
    {
      this.collapse( i );
    }
  },


  expand : function ( rowIdx )
  {
    if ( this.isCollapsed( rowIdx ) )
    {
      this.toggleRow( rowIdx, this.grid.getStore().getAt( rowIdx ) );
    }
  },


  expandAll : function ()
  {
    for ( i = 0; i < this.grid.getStore().getTotalCount(); i++ )
    {
      this.expand( i );
    }
  }
} );
