/*
 * Copyright (c) 2013-2018 QuartzDesk.com. All Rights Reserved.
 * QuartzDesk.com PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

/**
 * Refreshes the Scheduler Audit Trail tab in the scheduler view panel.
 */
Ext.define( 'QDesk.controller.command.scheduler.quartz.audit.RefreshSchedulerAuditTrailTab', {
  extend : 'QDesk.controller.command.BaseCommand',

  requires : [
    'QDesk.Msg',
    'QDesk.util.UxUtils',
    'QDesk.util.constant.ActionUrl',

    'QDesk.controller.command.scheduler.quartz.audit.RefreshSchedulerAuditTrailGrid'
  ],

  /*
   * Required connection ID of the scheduler whose tab should be refreshed.
   */
  connectionId : undefined,

  constructor : function ( config )
  {
    var me = this;

    config = config || {};

    if ( !config.connectionId )
      Ext.Error.raise( 'Required config parameter missing: connectionId' );

    me.callParent( [ config ] );
  },


  execute : function ()
  {
    var me = this;

    // refreshes the scheduler audit trail grid
    Ext.create( 'QDesk.controller.command.scheduler.quartz.audit.RefreshSchedulerAuditTrailGrid', {
      connectionId : me.connectionId,
      success : function ()
      {
      },
      failure : function ()
      {
      }
    } ).execute();
  }
} );
