/*
 * Copyright (c) 2013-2018 QuartzDesk.com. All Rights Reserved.
 * QuartzDesk.com PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

/**
 * Initializes the password reset process.
 */
Ext.define( 'QDesk.controller.command.security.ResetPasswordInit', {
  extend : 'QDesk.controller.command.BaseCommand',

  requires : [
    'QDesk.Msg',
    'QDesk.util.UxUtils'
  ],


  constructor : function ( config )
  {
    var me = this;

    config = config || {};

    if ( !config.username )
      Ext.Error.raise( 'Required config parameter missing: username' );

    me.callParent( [ config ] );
  },


  execute : function ()
  {
    var me = this;

    me.mask( QDesk.Msg.get( 'QDesk.controller.command.security.ResetPasswordInit.maskMsg' ) );

    Ext.Ajax.request( {
      url : QDesk.util.constant.ActionUrl.securityResetPasswordInit,
      callback : function ( opts, success, resp )
      {
        me.unmask();

        if ( success )
        {
          var json = Ext.decode( resp.responseText );
          if ( json.success )
          {
            // TODO: show message that a password reset link has been sent to the user's email address.
          }
          else
          {
            QDesk.util.UxUtils.showJsonResponseErrors( json );
          }
        }
        else
        {
          QDesk.util.UxUtils.showErrorDialog(
              QDesk.Msg.get( 'QDesk.controller.command.security.ResetPasswordInit.errorMsg' ) );
        }
      }
    } );
  }
} );
