/*
 * Copyright (c) 2013-2018 QuartzDesk.com. All Rights Reserved.
 * QuartzDesk.com PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

/**
 * A model used in the Connections tree view containing folder and scheduler nodes.
 */
Ext.define( 'QDesk.model.gui.ConnectionsTreeNode', {
  extend : 'Ext.data.Model',
  fields : [
    /*
     * Common fields.
     */
    { name : 'id', type : 'string' },
    { name : 'name', type : 'string' },

    /* Node type value is either 'folder', 'connection' */
    { name : 'nodeType', type : 'string' },

    /*
     * Folder specific fields.
     */
    { name : 'folderId', type : 'int', allowNull : true },

    /*
     * Common Connection fields.
     */
    { name : 'connectionId', type : 'int', allowNull : true },

    // Auxiliary enabled flag (false for connections disabled due to license restrictions).
    { name : 'enabled', type : 'boolean' }, // TODO: is it used?

    /*
     * Start of SchedulerConnection specific fields.
     */
    { name : 'schedulerObjectName', type : 'string', allowNull : true },

    // Scheduler type - see com.quartzdesk.domain.model.scheduler.SchedulerType
    { name : 'schedulerType', type : 'string', allowNull : true },

    // Scheduler version - see com.quartzdesk.domain.model.common.Version
    { name : 'schedulerVersion', allowNull : true },

    // Scheduler status - see com.quartzdesk.domain.model.scheduler.SchedulerStatus
    { name : 'schedulerStatus', type : 'string', allowNull : true },

    //
    // QuartzDesk Public API Library info - see com.quartzdesk.domain.model.scheduler.PublicApiInfo
    //
    { name : 'publicApiInfo', allowNull : true },

    //
    // QuartzDesk JVM Agent info object with the following structure:
    //  {
    //    compatible : true/false,
    //    compatibleVersion : true/false,
    //    compatibleEdition : true/false,
    //
    //    version : { major : value, minor : value, maintenance : value, qualifier : value }
    //    edition : string
    //  }
    //
    //
    { name : 'jvmAgentInfo', allowNull : true },

    { name : 'warningIconHtml', type : 'string' }

    /*
     * End of SchedulerConnection specific fields.
     */
  ]
} );
