/*
 * Copyright (c) 2013-2018 QuartzDesk.com. All Rights Reserved.
 * QuartzDesk.com PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

/**
 * A model describing a JavaScript scripting tree node. This model is used to build the JavaScript expression tree views.
 */
Ext.define( 'QDesk.model.gui.JSScriptingTreeNode', {
  extend : 'Ext.data.Model',
  fields : [

    { name : 'propertyName', type : 'string' },

    { name : 'propertyType', type : 'string' },

    {
      name : 'iconCls', type : 'string',
      convert : function ( newValue, model )
      {
        var propertyType = model.get( 'propertyType' );
        if ( propertyType == null )
        {
          return 'none';
        }
        else
        {
          return propertyType.toLowerCase();
        }
      }
    },

    { name : 'description', type : 'string' }
  ]
} );
