/*
 * Copyright (c) 2013-2018 QuartzDesk.com. All Rights Reserved.
 * QuartzDesk.com PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

/**
 * The user data model based on the com.quartzdesk.domain.model.security.Group class.
 */
Ext.define( 'QDesk.model.security.Group', {
  extend : 'Ext.data.Model',

  requires : [
    'QDesk.util.constant.DateFormat'
  ],

  fields : [
    { name : 'id', type : 'int', allowNull : true },

    { name : 'createdAt', type : 'date', dateFormat : QDesk.util.constant.DateFormat.timestampFormatIso8601 },
    { name : 'updatedAt', type : 'date', dateFormat : QDesk.util.constant.DateFormat.timestampFormatIso8601 },

    { name : 'name', type : 'string' },

    { name : 'system', type : 'boolean' },

    /*
     * The list of IDs of permissions associated with the user.
     */
    { name : 'permissionIds', type : 'auto', allowNull : true },

    /*
     * The list of IDs of users associated with the group (group members).
     */
    { name : 'userIds', type : 'auto', allowNull : true }
  ]
} );