/*
 * Copyright (c) 2013-2018 QuartzDesk.com. All Rights Reserved.
 * QuartzDesk.com PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

Ext.define( 'QDesk.store.enums.ExecStatusStore', {
  extend : 'Ext.data.Store',

  requires : [
    'QDesk.model.scheduler.ExecStatus',
    'QDesk.util.EnumUtils'
  ],

  storeId : 'enums.ExecStatusStore',

  fields : [ 'value', 'valueLabel' ],

  constructor : function ( config )
  {
    var me = this;

    config = config || {};

    Ext.apply( config, {
      data : [
        {
          value : QDesk.model.scheduler.ExecStatus.SUCCESS,
          valueLabel : QDesk.util.EnumUtils.getExecStatusName( QDesk.model.scheduler.ExecStatus.SUCCESS )
        },
        {
          value : QDesk.model.scheduler.ExecStatus.VETO,
          valueLabel : QDesk.util.EnumUtils.getExecStatusName( QDesk.model.scheduler.ExecStatus.VETO )
        },
        {
          value : QDesk.model.scheduler.ExecStatus.ERROR,
          valueLabel : QDesk.util.EnumUtils.getExecStatusName( QDesk.model.scheduler.ExecStatus.ERROR )
        }
      ]
    } );

    me.callParent( [ config ] );
  }
} );