/*
 * Copyright (c) 2013-2018 QuartzDesk.com. All Rights Reserved.
 * QuartzDesk.com PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

Ext.define( 'QDesk.store.enums.MessageReceiverWSVersionStore', {
  extend : 'Ext.data.Store',

  requires : [
    'QDesk.model.message.channel.web_service.MessageReceiverWSVersion',
    'QDesk.util.EnumUtils'
  ],

  storeId : 'enums.MessageReceiverWSVersionStore',

  fields : [ 'value', 'valueLabel' ],

  constructor : function ( config )
  {
    var me = this;

    config = config || {};

    Ext.apply( config, {
      data : [
        {
          value : QDesk.model.message.channel.web_service.MessageReceiverWSVersion.V5_0,
          valueLabel : QDesk.util.EnumUtils.getMessageReceiverWSVersionName(
              QDesk.model.message.channel.web_service.MessageReceiverWSVersion.V5_0 )
        },
        {
          value : QDesk.model.message.channel.web_service.MessageReceiverWSVersion.V10_0,
          valueLabel : QDesk.util.EnumUtils.getMessageReceiverWSVersionName(
              QDesk.model.message.channel.web_service.MessageReceiverWSVersion.V10_0 )
        }
      ]
    } );

    me.callParent( [ config ] );
  }
} );