/*
 * Copyright (c) 2013-2018 QuartzDesk.com. All Rights Reserved.
 * QuartzDesk.com PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

Ext.define( 'QDesk.store.enums.WSAuthenticationTypeStore', {
  extend : 'Ext.data.Store',

  requires : [
    'QDesk.Msg',
    'QDesk.model.message.channel.web_service.WSAuthenticationType',
    'QDesk.util.EnumUtils'
  ],

  storeId : 'enums.WSAuthenticationTypeStore',

  fields : [ 'value', 'valueLabel' ],

  constructor : function ( config )
  {
    var me = this;

    config = config || {};

    Ext.apply( config, {
      data : [
        {
          value : '',
          valueLabel : QDesk.Msg.get( 'QDesk.none' )
        },
        {
          value : QDesk.model.message.channel.web_service.WSAuthenticationType.HTTP_BASIC,
          valueLabel : QDesk.util.EnumUtils.getWSAuthenticationTypeName(
              QDesk.model.message.channel.web_service.WSAuthenticationType.HTTP_BASIC )
        },
        {
          value : QDesk.model.message.channel.web_service.WSAuthenticationType.WSS_USERNAME_TOKEN,
          valueLabel : QDesk.util.EnumUtils.getWSAuthenticationTypeName(
              QDesk.model.message.channel.web_service.WSAuthenticationType.WSS_USERNAME_TOKEN )
        }
      ]
    } );

    me.callParent( [ config ] );
  }
} );