/*
 * Copyright (c) 2013-2018 QuartzDesk.com. All Rights Reserved.
 * QuartzDesk.com PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

Ext.define( 'QDesk.store.enums.scheduler.JobChainTargetExecTypeStore', {
  extend : 'Ext.data.Store',

  requires : [
    'QDesk.model.scheduler.JobChainTargetExecType',
    'QDesk.util.EnumUtils'
  ],

  storeId : 'enums.scheduler.JobChainTargetExecTypeStore',

  fields : [ 'value', 'valueLabel' ],

  constructor : function ( config )
  {
    var me = this;

    config = config || {};

    Ext.apply( config, {
      data : [
        {
          value : QDesk.model.scheduler.JobChainTargetExecType.IMMEDIATE,
          valueLabel : QDesk.util.EnumUtils.getJobChainTargetExecTypeName(
              QDesk.model.scheduler.JobChainTargetExecType.IMMEDIATE )
        },
        {
          value : QDesk.model.scheduler.JobChainTargetExecType.DELAYED,
          valueLabel : QDesk.util.EnumUtils.getJobChainTargetExecTypeName(
              QDesk.model.scheduler.JobChainTargetExecType.DELAYED )
        },
        {
          value : QDesk.model.scheduler.JobChainTargetExecType.DATE_EXPRESSION,
          valueLabel : QDesk.util.EnumUtils.getJobChainTargetExecTypeName(
              QDesk.model.scheduler.JobChainTargetExecType.DATE_EXPRESSION )
        }
      ]
    } );

    me.callParent( [ config ] );
  }
} );