/*
 * Copyright (c) 2013-2018 QuartzDesk.com. All Rights Reserved.
 * QuartzDesk.com PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

Ext.define( 'QDesk.store.enums.scheduler.quartz.QuartzDateIntervalTriggerRepeatIntervalUnitStore', {
  extend : 'Ext.data.Store',

  requires : [
    'QDesk.model.scheduler.quartz.QuartzRepeatIntervalUnit',
    'QDesk.util.quartz.QuartzEnumUtils'
  ],

  fields : [ 'value', 'valueLabel' ],

  constructor : function ( config )
  {
    var me = this;

    config = config || {};

    if ( !config.qdesk )
      Ext.Error.raise( 'Required config parameter missing: qdesk' );

    if ( !config.qdesk.schedulerVersion )
      Ext.Error.raise( 'Required config parameter missing: qdesk.schedulerVersion' );

    var data = [];

    data.push( {
      value : QDesk.model.scheduler.quartz.QuartzRepeatIntervalUnit.SECOND,
      valueLabel : QDesk.util.quartz.QuartzEnumUtils.getRepeatIntervalUnitName(
          QDesk.model.scheduler.quartz.QuartzRepeatIntervalUnit.SECOND )
    } );

    data.push( {
      value : QDesk.model.scheduler.quartz.QuartzRepeatIntervalUnit.MINUTE,
      valueLabel : QDesk.util.quartz.QuartzEnumUtils.getRepeatIntervalUnitName(
          QDesk.model.scheduler.quartz.QuartzRepeatIntervalUnit.MINUTE )
    } );

    data.push( {
      value : QDesk.model.scheduler.quartz.QuartzRepeatIntervalUnit.HOUR,
      valueLabel : QDesk.util.quartz.QuartzEnumUtils.getRepeatIntervalUnitName(
          QDesk.model.scheduler.quartz.QuartzRepeatIntervalUnit.HOUR )
    } );

    data.push( {
      value : QDesk.model.scheduler.quartz.QuartzRepeatIntervalUnit.DAY,
      valueLabel : QDesk.util.quartz.QuartzEnumUtils.getRepeatIntervalUnitName(
          QDesk.model.scheduler.quartz.QuartzRepeatIntervalUnit.DAY )
    } );

    data.push( {
      value : QDesk.model.scheduler.quartz.QuartzRepeatIntervalUnit.WEEK,
      valueLabel : QDesk.util.quartz.QuartzEnumUtils.getRepeatIntervalUnitName(
          QDesk.model.scheduler.quartz.QuartzRepeatIntervalUnit.WEEK )
    } );

    data.push( {
      value : QDesk.model.scheduler.quartz.QuartzRepeatIntervalUnit.MONTH,
      valueLabel : QDesk.util.quartz.QuartzEnumUtils.getRepeatIntervalUnitName(
          QDesk.model.scheduler.quartz.QuartzRepeatIntervalUnit.MONTH )
    } );

    data.push( {
      value : QDesk.model.scheduler.quartz.QuartzRepeatIntervalUnit.YEAR,
      valueLabel : QDesk.util.quartz.QuartzEnumUtils.getRepeatIntervalUnitName(
          QDesk.model.scheduler.quartz.QuartzRepeatIntervalUnit.YEAR )
    } );

    Ext.apply( config, {
      data : data
    } );

    me.callParent( [ config ] );
  }
} );