/*
 * Copyright (c) 2013-2018 QuartzDesk.com. All Rights Reserved.
 * QuartzDesk.com PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

Ext.define( 'QDesk.store.enums.security.PermissionStore', {
  extend : 'Ext.data.Store',

  requires : [
    'QDesk.model.security.Permission',
    'QDesk.util.EnumUtils'
  ],

  storeId : 'enums.security.PermissionStore',

  fields : [ 'value', 'valueLabel' ],

  constructor : function ( config )
  {
    var me = this;

    config = config || {};

    Ext.apply( config, {
      data : [
        // system role, commented out
        // {
        //   value : 1,
        //   valueLabel : QDesk.util.EnumUtils.getPermissionName(
        //       QDesk.model.security.Permission.ADMINISTRATOR )
        // },


        // {
        //   value : 10,
        //   valueLabel : QDesk.util.EnumUtils.getPermissionName(
        //       QDesk.model.security.Permission.APP_SETTINGS_VIEW )
        // },
        {
          value : 11,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.APP_SETTINGS_UPDATE ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.APP_SETTINGS_UPDATE ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.APP_SETTINGS_UPDATE ) +
          '</span>'
        },


        // {
        //   value : 20,
        //   valueLabel : QDesk.util.EnumUtils.getPermissionName(
        //       QDesk.model.security.Permission.USER_VIEW )
        // },

        {
          value : 21,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.USER_ADD ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.USER_ADD ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.USER_ADD ) +
          '</span>'
        },
        {
          value : 22,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.USER_UPDATE ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.USER_UPDATE ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.USER_UPDATE ) +
          '</span>'
        },
        {
          value : 23,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.USER_DELETE ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.USER_DELETE ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.USER_DELETE ) +
          '</span>'
        },
        {
          value : 24,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.USER_LOCK_UPDATE ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.USER_LOCK_UPDATE ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.USER_LOCK_UPDATE ) +
          '</span>'
        },
        // {
        //   value : 25,
        //   valueLabel : QDesk.util.EnumUtils.getPermissionName(
        //       QDesk.model.security.Permission.USER_PERMISSIONS_UPDATE ),
        //   valueLabelWithTooltip : '<span data-qtip="' +
        //   QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.USER_PERMISSIONS_UPDATE ) +
        //   '">' +
        //   QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.USER_PERMISSIONS_UPDATE ) +
        //   '</span>'
        // },


        // {
        //   value : 30,
        //   valueLabel : QDesk.util.EnumUtils.getPermissionName(
        //       QDesk.model.security.Permission.GROUP_VIEW )
        // },
        {
          value : 31,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.GROUP_ADD ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.GROUP_ADD ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.GROUP_ADD ) +
          '</span>'
        },
        {
          value : 32,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.GROUP_UPDATE ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.GROUP_UPDATE ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.GROUP_UPDATE ) +
          '</span>'
        },
        {
          value : 33,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.GROUP_DELETE ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.GROUP_DELETE ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.GROUP_DELETE ) +
          '</span>'
        },
        // {
        //   value : 34,
        //   valueLabel : QDesk.util.EnumUtils.getPermissionName(
        //       QDesk.model.security.Permission.GROUP_MEMBERS_UPDATE ),
        //   valueLabelWithTooltip : '<span data-qtip="' +
        //   QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.GROUP_MEMBERS_UPDATE ) +
        //   '">' +
        //   QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.GROUP_MEMBERS_UPDATE ) +
        //   '</span>'
        // },
        // {
        //   value : 35,
        //   valueLabel : QDesk.util.EnumUtils.getPermissionName(
        //       QDesk.model.security.Permission.GROUP_PERMISSIONS_UPDATE ),
        //   valueLabelWithTooltip : '<span data-qtip="' +
        //   QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.GROUP_PERMISSIONS_UPDATE ) +
        //   '">' +
        //   QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.GROUP_PERMISSIONS_UPDATE ) +
        //   '</span>'
        // },


        {
          value : 40,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.SCHEDULER_START ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.SCHEDULER_START ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.SCHEDULER_START ) +
          '</span>'
        },
        {
          value : 41,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.SCHEDULER_PAUSE ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.SCHEDULER_PAUSE ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.SCHEDULER_PAUSE ) +
          '</span>'
        },
        {
          value : 42,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.SCHEDULER_STOP ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.SCHEDULER_STOP ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.SCHEDULER_STOP ) +
          '</span>'
        },


        // {
        //   value : 50,
        //   valueLabel : QDesk.util.EnumUtils.getPermissionName(
        //       QDesk.model.security.Permission.CONNECTION_VIEW )
        // },
        {
          value : 51,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.CONNECTION_ADD ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.CONNECTION_ADD ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.CONNECTION_ADD ) +
          '</span>'
        },
        {
          value : 52,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.CONNECTION_UPDATE ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.CONNECTION_UPDATE ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.CONNECTION_UPDATE ) +
          '</span>'
        },
        {
          value : 53,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.CONNECTION_DELETE ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.CONNECTION_DELETE ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.CONNECTION_DELETE ) +
          '</span>'
        },
        {
          value : 54,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.CONNECTION_MOVE ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.CONNECTION_MOVE ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.CONNECTION_MOVE ) +
          '</span>'
        },
        // {
        //   value : 55,
        //   valueLabel : QDesk.util.EnumUtils.getPermissionName(
        //       QDesk.model.security.Permission.CONNECTION_OPEN )
        // },


        {
          value : 60,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.CONNECTION_FLD_ADD ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.CONNECTION_FLD_ADD ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.CONNECTION_FLD_ADD ) +
          '</span>'
        },
        {
          value : 61,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.CONNECTION_FLD_UPDATE ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.CONNECTION_FLD_UPDATE ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.CONNECTION_FLD_UPDATE ) +
          '</span>'
        },
        {
          value : 62,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.CONNECTION_FLD_DELETE ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.CONNECTION_FLD_DELETE ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.CONNECTION_FLD_DELETE ) +
          '</span>'
        },
        {
          value : 63,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.CONNECTION_FLD_MOVE ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.CONNECTION_FLD_MOVE ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.CONNECTION_FLD_MOVE ) +
          '</span>'
        },


        // {
        //   value : 70,
        //   valueLabel : QDesk.util.EnumUtils.getPermissionName(
        //       QDesk.model.security.Permission.MSG_CHANNEL_PROFILE_VIEW )
        // },
        {
          value : 71,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.MSG_CHANNEL_PROFILE_ADD ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.MSG_CHANNEL_PROFILE_ADD ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.MSG_CHANNEL_PROFILE_ADD ) +
          '</span>'
        },
        {
          value : 72,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.MSG_CHANNEL_PROFILE_UPDATE ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.MSG_CHANNEL_PROFILE_UPDATE ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.MSG_CHANNEL_PROFILE_UPDATE ) +
          '</span>'
        },
        {
          value : 73,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.MSG_CHANNEL_PROFILE_DELETE ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.MSG_CHANNEL_PROFILE_DELETE ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.MSG_CHANNEL_PROFILE_DELETE ) +
          '</span>'
        },
        {
          value : 74,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.MSG_CHANNEL_PROFILE_MOVE ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.MSG_CHANNEL_PROFILE_MOVE ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.MSG_CHANNEL_PROFILE_MOVE ) +
          '</span>'
        },


        {
          value : 80,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.MSG_CHANNEL_PROFILE_FLD_ADD ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.MSG_CHANNEL_PROFILE_FLD_ADD ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.MSG_CHANNEL_PROFILE_FLD_ADD ) +
          '</span>'
        },
        {
          value : 81,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.MSG_CHANNEL_PROFILE_FLD_UPDATE ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription(
              QDesk.model.security.Permission.MSG_CHANNEL_PROFILE_FLD_UPDATE ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.MSG_CHANNEL_PROFILE_FLD_UPDATE ) +
          '</span>'
        },
        {
          value : 82,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.MSG_CHANNEL_PROFILE_FLD_DELETE ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription(
              QDesk.model.security.Permission.MSG_CHANNEL_PROFILE_FLD_DELETE ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.MSG_CHANNEL_PROFILE_FLD_DELETE ) +
          '</span>'
        },
        {
          value : 83,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.MSG_CHANNEL_PROFILE_FLD_MOVE ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription(
              QDesk.model.security.Permission.MSG_CHANNEL_PROFILE_FLD_MOVE ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.MSG_CHANNEL_PROFILE_FLD_MOVE ) +
          '</span>'
        },


        {
          value : 90,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.AUDIT_TRAIL_VIEW ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription(
              QDesk.model.security.Permission.AUDIT_TRAIL_VIEW ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.AUDIT_TRAIL_VIEW ) +
          '</span>'
        },


        // {
        //   value : 500,
        //   valueLabel : QDesk.util.EnumUtils.getPermissionName(
        //       QDesk.model.security.Permission.QUARTZ_JOB_VIEW )
        // },
        {
          value : 501,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.QUARTZ_JOB_ADD ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.QUARTZ_JOB_ADD ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.QUARTZ_JOB_ADD ) +
          '</span>'
        },
        {
          value : 502,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.QUARTZ_JOB_UPDATE ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.QUARTZ_JOB_UPDATE ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.QUARTZ_JOB_UPDATE ) +
          '</span>'
        },
        {
          value : 503,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.QUARTZ_JOB_DELETE ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.QUARTZ_JOB_DELETE ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.QUARTZ_JOB_DELETE ) +
          '</span>'
        },
        {
          value : 504,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.QUARTZ_JOB_TRIGGER_MANUALLY ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.QUARTZ_JOB_TRIGGER_MANUALLY ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.QUARTZ_JOB_TRIGGER_MANUALLY ) +
          '</span>'
        },
        {
          value : 505,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.QUARTZ_JOB_INTERRUPT ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.QUARTZ_JOB_INTERRUPT ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.QUARTZ_JOB_INTERRUPT ) +
          '</span>'
        },
        {
          value : 506,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.QUARTZ_JOB_THREAD_INFO_VIEW ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.QUARTZ_JOB_THREAD_INFO_VIEW ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.QUARTZ_JOB_THREAD_INFO_VIEW ) +
          '</span>'
        },


        {
          value : 510,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.QUARTZ_JOB_GROUP_PAUSE ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.QUARTZ_JOB_GROUP_PAUSE ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.QUARTZ_JOB_GROUP_PAUSE ) +
          '</span>'
        },
        {
          value : 511,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.QUARTZ_JOB_GROUP_RESUME ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.QUARTZ_JOB_GROUP_RESUME ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.QUARTZ_JOB_GROUP_RESUME ) +
          '</span>'
        },


        // {
        //   value : 520,
        //   valueLabel : QDesk.util.EnumUtils.getPermissionName(
        //       QDesk.model.security.Permission.QUARTZ_TRIGGER_VIEW )
        // },
        {
          value : 521,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.QUARTZ_TRIGGER_ADD ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.QUARTZ_TRIGGER_ADD ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.QUARTZ_TRIGGER_ADD ) +
          '</span>'
        },
        {
          value : 522,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.QUARTZ_TRIGGER_UPDATE ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.QUARTZ_TRIGGER_UPDATE ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.QUARTZ_TRIGGER_UPDATE ) +
          '</span>'
        },
        {
          value : 523,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.QUARTZ_TRIGGER_DELETE ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.QUARTZ_TRIGGER_DELETE ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.QUARTZ_TRIGGER_DELETE ) +
          '</span>'
        },
        {
          value : 524,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.QUARTZ_TRIGGER_PAUSE ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.QUARTZ_TRIGGER_PAUSE ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.QUARTZ_TRIGGER_PAUSE ) +
          '</span>'
        },
        {
          value : 525,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.QUARTZ_TRIGGER_RESUME ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.QUARTZ_TRIGGER_RESUME ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.QUARTZ_TRIGGER_RESUME ) +
          '</span>'
        },


        {
          value : 530,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.QUARTZ_TRIGGER_GROUP_PAUSE ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.QUARTZ_TRIGGER_GROUP_PAUSE ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.QUARTZ_TRIGGER_GROUP_PAUSE ) +
          '</span>'
        },
        {
          value : 531,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.QUARTZ_TRIGGER_GROUP_RESUME ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.QUARTZ_TRIGGER_GROUP_RESUME ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.QUARTZ_TRIGGER_GROUP_RESUME ) +
          '</span>'
        },


        // {
        //   value : 540,
        //   valueLabel : QDesk.util.EnumUtils.getPermissionName(
        //       QDesk.model.security.Permission.QUARTZ_EXEC_HISTORY_VIEW )
        // },
        {
          value : 541,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.QUARTZ_EXEC_HISTORY_EXPORT ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.QUARTZ_EXEC_HISTORY_EXPORT ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.QUARTZ_EXEC_HISTORY_EXPORT ) +
          '</span>'
        },


        // {
        //   value : 550,
        //   valueLabel : QDesk.util.EnumUtils.getPermissionName(
        //       QDesk.model.security.Permission.QUARTZ_EXEC_NOTIF_RULE_VIEW )
        // },
        {
          value : 551,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.QUARTZ_EXEC_NOTIF_RULE_ADD ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.QUARTZ_EXEC_NOTIF_RULE_ADD ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.QUARTZ_EXEC_NOTIF_RULE_ADD ) +
          '</span>'
        },
        {
          value : 552,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.QUARTZ_EXEC_NOTIF_RULE_UPDATE ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription(
              QDesk.model.security.Permission.QUARTZ_EXEC_NOTIF_RULE_UPDATE ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.QUARTZ_EXEC_NOTIF_RULE_UPDATE ) +
          '</span>'
        },
        {
          value : 553,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.QUARTZ_EXEC_NOTIF_RULE_DELETE ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription(
              QDesk.model.security.Permission.QUARTZ_EXEC_NOTIF_RULE_DELETE ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.QUARTZ_EXEC_NOTIF_RULE_DELETE ) +
          '</span>'
        },


        // {
        //   value : 560,
        //   valueLabel : QDesk.util.EnumUtils.getPermissionName(
        //       QDesk.model.security.Permission.QUARTZ_JOB_CHAIN_VIEW )
        // },
        {
          value : 561,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.QUARTZ_JOB_CHAIN_ADD ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.QUARTZ_JOB_CHAIN_ADD ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.QUARTZ_JOB_CHAIN_ADD ) +
          '</span>'
        },
        {
          value : 562,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.QUARTZ_JOB_CHAIN_UPDATE ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.QUARTZ_JOB_CHAIN_UPDATE ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.QUARTZ_JOB_CHAIN_UPDATE ) +
          '</span>'
        },
        {
          value : 563,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.QUARTZ_JOB_CHAIN_DELETE ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.QUARTZ_JOB_CHAIN_DELETE ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.QUARTZ_JOB_CHAIN_DELETE ) +
          '</span>'
        },


        {
          value : 1000,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.WS_CONNECTION ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.WS_CONNECTION ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.WS_CONNECTION ) +
          '</span>'
        },
        {
          value : 1001,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.WS_SECURITY ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.WS_SECURITY ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.WS_SECURITY ) +
          '</span>'
        },
        {
          value : 1002,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.WS_MESSAGE_CHANNEL_PROFILE ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.WS_MESSAGE_CHANNEL_PROFILE ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.WS_MESSAGE_CHANNEL_PROFILE ) +
          '</span>'
        },
        {
          value : 1010,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.WS_QUARTZ ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.WS_QUARTZ ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.WS_QUARTZ ) +
          '</span>'
        },
        {
          value : 1011,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.WS_QUARTZ_EXEC_HISTORY ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.WS_QUARTZ_EXEC_HISTORY ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.WS_QUARTZ_EXEC_HISTORY ) +
          '</span>'
        },
        {
          value : 1012,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.WS_QUARTZ_EXEC_NOTIF_RULE ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.WS_QUARTZ_EXEC_NOTIF_RULE ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.WS_QUARTZ_EXEC_NOTIF_RULE ) +
          '</span>'
        },
        {
          value : 1013,
          valueLabel : QDesk.util.EnumUtils.getPermissionName(
              QDesk.model.security.Permission.WS_QUARTZ_JOB_CHAIN ),
          valueLabelWithTooltip : '<span data-qtip="' +
          QDesk.util.EnumUtils.getPermissionDescription( QDesk.model.security.Permission.WS_QUARTZ_JOB_CHAIN ) +
          '">' +
          QDesk.util.EnumUtils.getPermissionName( QDesk.model.security.Permission.WS_QUARTZ_JOB_CHAIN ) +
          '</span>'
        }
      ],

      sorters : {
        property : 'valueLabel',
        direction : 'ASC'
      }
    } );

    me.callParent( [ config ] );
  }
} );
