/*
 * Copyright (c) 2013-2018 QuartzDesk.com. All Rights Reserved.
 * QuartzDesk.com PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

Ext.define( 'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore', {
  extend : 'Ext.data.TreeStore',

  requires : [
    'QDesk.model.gui.MessageMacroTreeNode'
  ],

  model : 'QDesk.model.gui.MessageMacroTreeNode',

  constructor : function ( config )
  {
    var me = this;

    config = config || {};

    var root = {
      children : [
        /* ExecHistory record */
        {
          macroName : 'execHistory',
          description : QDesk.Msg.get(
              'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.execHistory' ),
          leaf : false,
          children : [
            {
              macroName : 'execHistory.id',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.execHistory.execHistoryId' ),
              leaf : true
            },
            {
              macroName : 'execHistory.startedAt',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.execHistory.startedAt' ),
              leaf : true
            },
            {
              macroName : 'execHistory.finishedAt',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.execHistory.finishedAt' ),
              leaf : true
            },
            {
              macroName : 'execHistory.duration',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.execHistory.duration' ),
              leaf : true
            },
            {
              macroName : 'execHistory.execStatus',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.execHistory.execStatus' ),
              leaf : true
            },

            /* Scheduler info */
            {
              macroName : 'execHistory.schedulerObjectName',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.execHistory.schedulerObjectName' ),
              leaf : true
            },
            {
              macroName : 'execHistory.schedulerVersion',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.execHistory.schedulerVersion' ),
              leaf : true
            },
            {
              macroName : 'execHistory.schedulerName',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.execHistory.schedulerName' ),
              leaf : true
            },
            {
              macroName : 'execHistory.schedulerInstanceId',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.execHistory.schedulerInstanceId' ),
              leaf : true
            },

            /* Job info */
            {
              macroName : 'execHistory.jobClassName',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.execHistory.jobClassName' ),
              leaf : true
            },
            {
              macroName : 'execHistory.jobClassLocation',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.execHistory.jobClassLocation' ),
              leaf : true
            },
            {
              macroName : 'execHistory.jobGroupName',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.execHistory.jobGroupName' ),
              leaf : true
            },
            {
              macroName : 'execHistory.jobName',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.execHistory.jobName' ),
              leaf : true
            },
            {
              macroName : 'execHistory.jobDataMap',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.execHistory.jobDataMap' ),
              leaf : true
            },
            {
              macroName : 'execHistory.triggerGroupName',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.execHistory.triggerGroupName' ),
              leaf : true
            },
            {
              macroName : 'execHistory.triggerName',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.execHistory.triggerName' ),
              leaf : true
            },
            {
              macroName : 'execHistory.calendarName',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.execHistory.calendarName' ),
              leaf : true
            },

            /* Blobs */
            {
              macroName : 'execHistory.result',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.execHistory.result' ),
              leaf : true
            },
            {
              macroName : 'execHistory.userData',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.execHistory.userData' ),
              leaf : true
            },
            {
              macroName : 'execHistory.error',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.execHistory.error' ),
              leaf : true
            },
            {
              macroName : 'execHistory.log',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.execHistory.log' ),
              leaf : true
            },

            /* Thread info */
            {
              macroName : 'execHistory.threadGroupName',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.execHistory.threadGroupName' ),
              leaf : true
            },
            {
              macroName : 'execHistory.threadName',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.execHistory.threadName' ),
              leaf : true
            },
            {
              macroName : 'execHistory.threadPriority',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.execHistory.threadPriority' ),
              leaf : true
            },

            /* Host info */
            {
              macroName : 'execHistory.hostName',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.execHistory.hostName' ),
              leaf : true
            },

            /* JVM info */
            {
              macroName : 'execHistory.jvmPid',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.execHistory.jvmPid' ),
              leaf : true
            },
            {
              macroName : 'execHistory.jvmName',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.execHistory.jvmName' ),
              leaf : true
            },
            {
              macroName : 'execHistory.jvmVendor',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.execHistory.jvmVendor' ),
              leaf : true
            },
            {
              macroName : 'execHistory.jvmVersion',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.execHistory.jvmVersion' ),
              leaf : true
            },
            {
              macroName : 'execHistory.jvmRuntimeVersion',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.execHistory.jvmRuntimeVersion' ),
              leaf : true
            },

            /* OS info */
            {
              macroName : 'execHistory.osName',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.execHistory.osName' ),
              leaf : true
            },
            {
              macroName : 'execHistory.osArch',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.execHistory.osArch' ),
              leaf : true
            }
          ]
        },

        /* Preceding ExecHistory record */
        {
          macroName : 'precedingExecHistory',
          description : QDesk.Msg.get(
              'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.precedingExecHistory' ),
          leaf : false,
          children : [
            {
              macroName : 'precedingExecHistory.id',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.precedingExecHistory.execHistoryId' ),
              leaf : true
            },
            {
              macroName : 'precedingExecHistory.startedAt',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.precedingExecHistory.startedAt' ),
              leaf : true
            },
            {
              macroName : 'precedingExecHistory.finishedAt',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.precedingExecHistory.finishedAt' ),
              leaf : true
            },
            {
              macroName : 'precedingExecHistory.duration',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.precedingExecHistory.duration' ),
              leaf : true
            },
            {
              macroName : 'precedingExecHistory.execStatus',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.precedingExecHistory.execStatus' ),
              leaf : true
            },

            /* Scheduler info */
            {
              macroName : 'precedingExecHistory.schedulerObjectName',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.precedingExecHistory.schedulerObjectName' ),
              leaf : true
            },
            {
              macroName : 'precedingExecHistory.schedulerVersion',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.precedingExecHistory.schedulerVersion' ),
              leaf : true
            },
            {
              macroName : 'precedingExecHistory.schedulerName',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.precedingExecHistory.schedulerName' ),
              leaf : true
            },
            {
              macroName : 'precedingExecHistory.schedulerInstanceId',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.precedingExecHistory.schedulerInstanceId' ),
              leaf : true
            },

            /* Job info */
            {
              macroName : 'precedingExecHistory.jobClassName',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.precedingExecHistory.jobClassName' ),
              leaf : true
            },
            {
              macroName : 'precedingExecHistory.jobClassLocation',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.precedingExecHistory.jobClassLocation' ),
              leaf : true
            },
            {
              macroName : 'precedingExecHistory.jobGroupName',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.precedingExecHistory.jobGroupName' ),
              leaf : true
            },
            {
              macroName : 'precedingExecHistory.jobName',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.precedingExecHistory.jobName' ),
              leaf : true
            },
            {
              macroName : 'precedingExecHistory.jobDataMap',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.precedingExecHistory.jobDataMap' ),
              leaf : true
            },
            {
              macroName : 'precedingExecHistory.triggerGroupName',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.precedingExecHistory.triggerGroupName' ),
              leaf : true
            },
            {
              macroName : 'precedingExecHistory.triggerName',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.precedingExecHistory.triggerName' ),
              leaf : true
            },
            {
              macroName : 'precedingExecHistory.calendarName',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.precedingExecHistory.calendarName' ),
              leaf : true
            },

            /* Blobs */
            {
              macroName : 'precedingExecHistory.result',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.precedingExecHistory.result' ),
              leaf : true
            },
            {
              macroName : 'precedingExecHistory.userData',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.precedingExecHistory.userData' ),
              leaf : true
            },
            {
              macroName : 'precedingExecHistory.error',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.precedingExecHistory.error' ),
              leaf : true
            },
            {
              macroName : 'precedingExecHistory.log',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.precedingExecHistory.log' ),
              leaf : true
            },

            /* Thread info */
            {
              macroName : 'precedingExecHistory.threadGroupName',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.precedingExecHistory.threadGroupName' ),
              leaf : true
            },
            {
              macroName : 'precedingExecHistory.threadName',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.precedingExecHistory.threadName' ),
              leaf : true
            },
            {
              macroName : 'precedingExecHistory.threadPriority',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.precedingExecHistory.threadPriority' ),
              leaf : true
            },

            /* Host info */
            {
              macroName : 'precedingExecHistory.hostName',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.precedingExecHistory.hostName' ),
              leaf : true
            },

            /* JVM info */
            {
              macroName : 'precedingExecHistory.jvmPid',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.precedingExecHistory.jvmPid' ),
              leaf : true
            },
            {
              macroName : 'precedingExecHistory.jvmName',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.precedingExecHistory.jvmName' ),
              leaf : true
            },
            {
              macroName : 'precedingExecHistory.jvmVendor',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.precedingExecHistory.jvmVendor' ),
              leaf : true
            },
            {
              macroName : 'precedingExecHistory.jvmVersion',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.precedingExecHistory.jvmVersion' ),
              leaf : true
            },
            {
              macroName : 'precedingExecHistory.jvmRuntimeVersion',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.precedingExecHistory.jvmRuntimeVersion' ),
              leaf : true
            },

            /* OS info */
            {
              macroName : 'precedingExecHistory.osName',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.precedingExecHistory.osName' ),
              leaf : true
            },
            {
              macroName : 'precedingExecHistory.osArch',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzExecNotificationRuleMessageMacrosTreeStore.precedingExecHistory.osArch' ),
              leaf : true
            }
          ]
        }
      ]
    };

    Ext.apply( config, {
      root : root
    } );

    me.callParent( [ config ] );
  }
} )
;
