/*
 * Copyright (c) 2013-2018 QuartzDesk.com. All Rights Reserved.
 * QuartzDesk.com PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

Ext.define( 'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore', {
  extend : 'Ext.data.TreeStore',

  requires : [
    'QDesk.model.gui.JSScriptingTreeNode'
  ],

  model : 'QDesk.model.gui.JSScriptingTreeNode',

  defaultRootText : '',

  constructor : function ( config )
  {
    var me = this;

    config = config || {};

    var root = {
      children : [
        /* DayTime type */
        {
          propertyName : 'DayTime',
          propertyType : 'Object',
          description : QDesk.Msg.get(
              'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.DayTime' ),
          leaf : false,
          children : [
            {
              propertyName : 'hours',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.DayTime.hours' ),
              leaf : true
            },
            {
              propertyName : 'minutes',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.DayTime.minutes' ),
              leaf : true
            },
            {
              propertyName : 'seconds',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.DayTime.seconds' ),
              leaf : true
            }
          ]
        },


        /* ExecHealthIndicatorEntry type */
        {
          propertyName : 'ExecHealthIndicatorEntry',
          propertyType : 'Object',
          description : QDesk.Msg.get(
              'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.ExecHealthIndicatorEntry' ),
          leaf : false,
          children : [
            {
              propertyName : 'execHistoryId',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.ExecHealthIndicatorEntry.execHistoryId' ),
              leaf : true
            },
            {
              propertyName : 'startedAt',
              propertyType : 'Date',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.ExecHealthIndicatorEntry.startedAt' ),
              leaf : true
            },
            {
              propertyName : 'finishedAt',
              propertyType : 'Date',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.ExecHealthIndicatorEntry.finishedAt' ),
              leaf : true
            },
            {
              propertyName : 'duration',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.ExecHealthIndicatorEntry.duration' ),
              leaf : true
            },
            {
              propertyName : 'execStatus',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.ExecHealthIndicatorEntry.execStatus' ),
              leaf : true
            }
          ]
        },


        /* FixedTimePeriod type */
        {
          propertyName : 'FixedTimePeriod',
          propertyType : 'Object',
          description : QDesk.Msg.get(
              'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.FixedTimePeriod' ),
          leaf : false,
          children : [
            {
              propertyName : 'length',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.FixedTimePeriod.length' ),
              leaf : true
            },
            {
              propertyName : 'firstWeekDay',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.FixedTimePeriod.firstWeekDay' ),
              leaf : true
            },
            {
              propertyName : 'from',
              propertyType : 'Date',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.FixedTimePeriod.from' ),
              leaf : true
            },
            {
              propertyName : 'to',
              propertyType : 'Date',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.FixedTimePeriod.to' ),
              leaf : true
            }
          ]
        },


        /* TimeZone type */
        {
          propertyName : 'TimeZone',
          propertyType : 'Object',
          description : QDesk.Msg.get(
              'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.TimeZone' ),
          leaf : false,
          children : [
            {
              propertyName : 'id',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.TimeZone.id' ),
              leaf : true
            },
            {
              propertyName : 'displayName',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.TimeZone.displayName' ),
              leaf : true
            },
            {
              propertyName : 'offset',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.TimeZone.offset' ),
              leaf : true
            }
          ]
        },


        /* Version type */
        {
          propertyName : 'Version',
          propertyType : 'Object',
          description : QDesk.Msg.get(
              'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.Version' ),
          leaf : false,
          children : [
            {
              propertyName : 'major',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.Version.major' ),
              leaf : true
            },
            {
              propertyName : 'minor',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.Version.minor' ),
              leaf : true
            },
            {
              propertyName : 'maintenance',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.Version.maintenance' ),
              leaf : true
            },
            {
              propertyName : 'qualifier',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.Version.qualifier' ),
              leaf : true
            }
          ]
        },


        /* ExecHistory type */
        {
          propertyName : 'ExecHistory',
          propertyType : 'Object',
          description : QDesk.Msg.get(
              'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.ExecHistory' ),
          leaf : false,
          children : [
            {
              propertyName : 'id',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.ExecHistory.id' ),
              leaf : true
            },
            {
              propertyName : 'startedAt',
              propertyType : 'Date',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.ExecHistory.startedAt' ),
              leaf : true
            },
            {
              propertyName : 'finishedAt',
              propertyType : 'Date',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.ExecHistory.finishedAt' ),
              leaf : true
            },
            {
              propertyName : 'duration',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.ExecHistory.duration' ),
              leaf : true
            },
            {
              propertyName : 'execStatus',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.ExecHistory.execStatus' ),
              leaf : true
            },
            {
              propertyName : 'execType',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.ExecHistory.execType' ),
              leaf : true
            },

            /* Scheduler info */
            {
              propertyName : 'schedulerObjectName',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.ExecHistory.schedulerObjectName' ),
              leaf : true
            },
            {
              propertyName : 'schedulerVersion',
              propertyType : 'Object',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.ExecHistory.schedulerVersion' ),
              leaf : true
            },

            /* Job info */
            {
              propertyName : 'jobClassName',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.ExecHistory.jobClassName' ),
              leaf : true
            },
            {
              propertyName : 'jobClassLocation',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.ExecHistory.jobClassLocation' ),
              leaf : true
            },
            {
              propertyName : 'jobExecutionId',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.ExecHistory.jobExecutionId' ),
              leaf : true
            },

            /* Blobs */
            {
              propertyName : 'result',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.ExecHistory.result' ),
              leaf : true
            },
            {
              propertyName : 'error',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.ExecHistory.error' ),
              leaf : true
            },
            {
              propertyName : 'userData',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.ExecHistory.userData' ),
              leaf : true
            },
            {
              propertyName : 'log',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.ExecHistory.log' ),
              leaf : true
            },

            /* Thread info */
            {
              propertyName : 'threadGroupName',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.ExecHistory.threadGroupName' ),
              leaf : true
            },
            {
              propertyName : 'threadName',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.ExecHistory.threadName' ),
              leaf : true
            },
            {
              propertyName : 'threadPriority',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.ExecHistory.threadPriority' ),
              leaf : true
            },

            /* Host info */
            {
              propertyName : 'hostName',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.ExecHistory.hostName' ),
              leaf : true
            },

            /* JVM info */
            {
              propertyName : 'jvmPid',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.ExecHistory.jvmPid' ),
              leaf : true
            },
            {
              propertyName : 'jvmName',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.ExecHistory.jvmName' ),
              leaf : true
            },
            {
              propertyName : 'jvmVendor',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.ExecHistory.jvmVendor' ),
              leaf : true
            },
            {
              propertyName : 'jvmVersion',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.ExecHistory.jvmVersion' ),
              leaf : true
            },
            {
              propertyName : 'jvmRuntimeVersion',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.ExecHistory.jvmRuntimeVersion' ),
              leaf : true
            },

            /* OS info */
            {
              propertyName : 'osName',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.ExecHistory.osName' ),
              leaf : true
            },
            {
              propertyName : 'osArch',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.ExecHistory.osArch' ),
              leaf : true
            },

            /* Job chain related attributes */
            {
              propertyName : 'jobChainId',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.ExecHistory.jobChainId' ),
              leaf : true
            },
            {
              propertyName : 'jobChainFlowId',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.ExecHistory.jobChainFlowId' ),
              leaf : true
            },
            {
              propertyName : 'jobChainSrcExecHistoryId',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.ExecHistory.jobChainSrcExecHistoryId' ),
              leaf : true
            }
          ]
        },


        /* QuartzCalendar */
        {
          propertyName : 'QuartzCalendar',
          propertyType : 'Object',
          description : QDesk.Msg.get(
              'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzCalendar' ),
          leaf : false,
          children : [
            {
              propertyName : 'id',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzCalendar.id' ),
              leaf : true
            },
            {
              propertyName : 'displayName',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzCalendar.displayName' ),
              leaf : true
            }
          ]
        },


        /* QuartzCalendarIntervalTrigger */
        {
          propertyName : 'QuartzCalendarIntervalTrigger',
          propertyType : 'Object',
          description : QDesk.Msg.get(
              'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzCalendarIntervalTrigger' ),
          leaf : false,
          children : [
            {
              propertyName : 'repeatInterval',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzCalendarIntervalTrigger.repeatInterval' ),
              leaf : true
            },
            {
              propertyName : 'repeatIntervalUnit',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzCalendarIntervalTrigger.repeatIntervalUnit' ),
              leaf : true
            },
            {
              propertyName : 'timeZone',
              propertyType : 'Object',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzCalendarIntervalTrigger.timeZone' ),
              leaf : true
            },
            {
              propertyName : 'preserveHourOfDayAcrossDaylightSavings',
              propertyType : 'Boolean',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzCalendarIntervalTrigger.preserveHourOfDayAcrossDaylightSavings' ),
              leaf : true
            },
            {
              propertyName : 'skipDayIfHourDoesNotExist',
              propertyType : 'Boolean',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzCalendarIntervalTrigger.skipDayIfHourDoesNotExist' ),
              leaf : true
            }
          ]
        },

        /* QuartzCronTrigger */
        {
          propertyName : 'QuartzCronTrigger',
          propertyType : 'Object',
          description : QDesk.Msg.get(
              'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzCronTrigger' ),
          leaf : false,
          children : [
            {
              propertyName : 'cronExpression',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzCronTrigger.cronExpression' ),
              leaf : true
            },
            {
              propertyName : 'timeZone',
              propertyType : 'Object',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzCronTrigger.timeZone' ),
              leaf : true
            }
          ]
        },


        /* QuartzDailyTimeIntervalTrigger */
        {
          propertyName : 'QuartzDailyTimeIntervalTrigger',
          propertyType : 'Object',
          description : QDesk.Msg.get(
              'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzDailyTimeIntervalTrigger' ),
          leaf : false,
          children : [
            {
              propertyName : 'repeatInterval',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzDailyTimeIntervalTrigger.repeatInterval' ),
              leaf : true
            },
            {
              propertyName : 'repeatIntervalUnit',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzDailyTimeIntervalTrigger.repeatIntervalUnit' ),
              leaf : true
            },
            {
              propertyName : 'repeatCount',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzDailyTimeIntervalTrigger.repeatCount' ),
              leaf : true
            },
            {
              propertyName : 'startTimeOfDay',
              propertyType : 'Object',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzDailyTimeIntervalTrigger.startTimeOfDay' ),
              leaf : true
            },
            {
              propertyName : 'endTimeOfDay',
              propertyType : 'Object',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzDailyTimeIntervalTrigger.endTimeOfDay' ),
              leaf : true
            }, {
              propertyName : 'daysOfWeek',
              propertyType : 'Array',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzDailyTimeIntervalTrigger.daysOfWeek' ),
              leaf : true
            }
          ]
        },


        /* QuartzDateIntervalTrigger */
        {
          propertyName : 'QuartzDateIntervalTrigger',
          propertyType : 'Object',
          description : QDesk.Msg.get(
              'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzDateIntervalTrigger' ),
          leaf : false,
          children : [
            {
              propertyName : 'repeatInterval',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzDateIntervalTrigger.repeatInterval' ),
              leaf : true
            },
            {
              propertyName : 'repeatIntervalUnit',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzDateIntervalTrigger.repeatIntervalUnit' ),
              leaf : true
            }
          ]
        },


        /* QuartzExecHistory type */
        {
          propertyName : 'QuartzExecHistory',
          propertyType : 'Object',
          description : QDesk.Msg.get(
              'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecHistory' ),
          leaf : false,
          children : [
            /* Scheduler info */
            {
              propertyName : 'schedulerName',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecHistory.schedulerName' ),
              leaf : true
            },
            {
              propertyName : 'schedulerInstanceId',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecHistory.schedulerInstanceId' ),
              leaf : true
            },

            /* Job info */
            {
              propertyName : 'jobGroupName',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecHistory.jobGroupName' ),
              leaf : true
            },
            {
              propertyName : 'jobName',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecHistory.jobName' ),
              leaf : true
            },
            {
              propertyName : 'jobDataMap',
              propertyType : 'Array',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecHistory.jobDataMap' ),
              leaf : true
            },

            /* Trigger info */
            {
              propertyName : 'triggerGroupName',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecHistory.triggerGroupName' ),
              leaf : true
            },
            {
              propertyName : 'triggerName',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecHistory.triggerName' ),
              leaf : true
            },

            {
              propertyName : 'calendarName',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecHistory.calendarName' ),
              leaf : true
            }
          ]
        },


        /* QuartzExecStatData */
        {
          propertyName : 'QuartzExecStatData',
          propertyType : 'Object',
          description : QDesk.Msg.get(
              'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecStatData' ),
          leaf : false,
          children : [
            {
              propertyName : 'periodStart',
              propertyType : 'Date',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecStatData.periodStart' ),
              leaf : true
            },
            {
              propertyName : 'periodEnd',
              propertyType : 'Date',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecStatData.periodEnd' ),
              leaf : true
            },
            {
              propertyName : 'periodLength',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecStatData.periodLength' ),
              leaf : true
            },
            {
              propertyName : 'complete',
              propertyType : 'Boolean',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecStatData.complete' ),
              leaf : true
            },

            {
              propertyName : 'jobGroupName',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecStatData.jobGroupName' ),
              leaf : true
            },
            {
              propertyName : 'jobName',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecStatData.jobName' ),
              leaf : true
            },

            {
              propertyName : 'triggerGroupName',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecStatData.triggerGroupName' ),
              leaf : true
            },
            {
              propertyName : 'triggerName',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecStatData.triggerName' ),
              leaf : true
            },

            {
              propertyName : 'countSuccess',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecStatData.countSuccess' ),
              leaf : true
            },
            {
              propertyName : 'countVeto',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecStatData.countVeto' ),
              leaf : true
            },
            {
              propertyName : 'countError',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecStatData.countError' ),
              leaf : true
            },
            {
              propertyName : 'countSuccessAndError',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecStatData.countSuccessAndError' ),
              leaf : true
            },

            {
              propertyName : 'timeSuccess',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecStatData.timeSuccess' ),
              leaf : true
            },
            {
              propertyName : 'timeVeto',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecStatData.timeVeto' ),
              leaf : true
            },
            {
              propertyName : 'timeError',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecStatData.timeError' ),
              leaf : true
            },
            {
              propertyName : 'timeSuccessAndError',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecStatData.timeSuccessAndError' ),
              leaf : true
            },

            {
              propertyName : 'avgTimeSuccess',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecStatData.avgTimeSuccess' ),
              leaf : true
            },
            {
              propertyName : 'avgTimeVeto',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecStatData.avgTimeVeto' ),
              leaf : true
            },
            {
              propertyName : 'avgTimeError',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecStatData.avgTimeError' ),
              leaf : true
            },
            {
              propertyName : 'avgTimeSuccessAndError',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecStatData.avgTimeSuccessAndError' ),
              leaf : true
            }
          ]
        },


        /* QuartzExecutingJob type */
        {
          propertyName : 'QuartzExecutingJob',
          propertyType : 'Object',
          description : QDesk.Msg.get(
              'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecutingJob' ),
          leaf : false,
          children : [
            {
              propertyName : 'jobDetail',
              propertyType : 'Object',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecutingJob.jobDetail' ),
              leaf : true
            },
            {
              propertyName : 'trigger',
              propertyType : 'Object',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecutingJob.trigger' ),
              leaf : true
            },
            {
              propertyName : 'execType',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecutingJob.execType' ),
              leaf : true
            },
            {
              propertyName : 'jobDataMap',
              propertyType : 'Array',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecutingJob.jobDataMap' ),
              leaf : true
            },
            {
              propertyName : 'calendarName',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecutingJob.calendarName' ),
              leaf : true
            },

            {
              propertyName : 'fireInstanceId',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecutingJob.fireInstanceId' ),
              leaf : true
            },
            {
              propertyName : 'jobExecutionId',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecutingJob.jobExecutionId' ),
              leaf : true
            },

            {
              propertyName : 'fireTime',
              propertyType : 'Date',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecutingJob.fireTime' ),
              leaf : true
            },
            {
              propertyName : 'scheduledFireTime',
              propertyType : 'Date',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecutingJob.scheduledFireTime' ),
              leaf : true
            },
            {
              propertyName : 'nextFireTime',
              propertyType : 'Date',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecutingJob.nextFireTime' ),
              leaf : true
            },
            {
              propertyName : 'previousFireTime',
              propertyType : 'Date',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecutingJob.previousFireTime' ),
              leaf : true
            },

            {
              propertyName : 'recovering',
              propertyType : 'Boolean',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecutingJob.recovering' ),
              leaf : true
            },
            {
              propertyName : 'refireCount',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecutingJob.refireCount' ),
              leaf : true
            },

            /* Job chain related attributes */
            {
              propertyName : 'jobChainId',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecutingJob.jobChainId' ),
              leaf : true
            },
            {
              propertyName : 'jobChainFlowId',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecutingJob.jobChainFlowId' ),
              leaf : true
            },
            {
              propertyName : 'jobChainSrcExecHistoryId',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzExecutingJob.jobChainSrcExecHistoryId' ),
              leaf : true
            }
          ]
        },


        /* QuartzJobDataMapEntry type */
        {
          propertyName : 'QuartzJobDataMapEntry',
          propertyType : 'Object',
          description : QDesk.Msg.get(
              'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzJobDataMapEntry' ),
          leaf : false,
          children : [
            {
              propertyName : 'name',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzJobDataMapEntry.name' ),
              leaf : true
            },
            {
              propertyName : 'value',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzJobDataMapEntry.value' ),
              leaf : true
            }
          ]
        },


        /* QuartzJobDetail */
        {
          propertyName : 'QuartzJobDetail',
          propertyType : 'Object',
          description : QDesk.Msg.get(
              'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzJobDetail' ),
          leaf : false,
          children : [
            {
              propertyName : 'name',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzJobDetail.name' ),
              leaf : true
            },
            {
              propertyName : 'groupName',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzJobDetail.groupName' ),
              leaf : true
            },
            {
              propertyName : 'description',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzJobDetail.description' ),
              leaf : true
            },
            {
              propertyName : 'durability',
              propertyType : 'Boolean',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzJobDetail.durability' ),
              leaf : true
            },
            {
              propertyName : 'shouldRecover',
              propertyType : 'Boolean',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzJobDetail.shouldRecover' ),
              leaf : true
            },
            {
              propertyName : 'jobClass',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzJobDetail.jobClass' ),
              leaf : true
            },
            {
              propertyName : 'jobDataMap',
              propertyType : 'Array',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzJobDetail.jobDataMap' ),
              leaf : true
            },
            {
              propertyName : 'volatility',
              propertyType : 'Boolean',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzJobDetail.volatility' ),
              leaf : true
            },
            {
              propertyName : 'concurrentExecutionDisallowed',
              propertyType : 'Boolean',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzJobDetail.concurrentExecutionDisallowed' ),
              leaf : true
            },
            {
              propertyName : 'persistJobDataAfterExecution',
              propertyType : 'Boolean',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzJobDetail.persistJobDataAfterExecution' ),
              leaf : true
            },
            {
              propertyName : 'nextFireTime',
              propertyType : 'Date',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzJobDetail.nextFireTime' ),
              leaf : true
            },
            // {
            //   propertyName : 'monitoringUrl',
            //   propertyType : 'String',
            //   description : QDesk.Msg.get(
            //       'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzJobDetail.monitoringUrl' ),
            //   leaf : true
            // },
            {
              propertyName : 'execHealthIndicator',
              propertyType : 'Object',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzJobDetail.execHealthIndicator' ),
              leaf : true
            }
          ]
        },


        /* QuartzNthIncludedDayTrigger */
        {
          propertyName : 'QuartzNthIncludedDayTrigger',
          propertyType : 'Object',
          description : QDesk.Msg.get(
              'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzNthIncludedDayTrigger' ),
          leaf : false,
          children : [
            {
              propertyName : 'nthDay',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzNthIncludedDayTrigger.nthDay' ),
              leaf : true
            },
            {
              propertyName : 'intervalType',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzNthIncludedDayTrigger.intervalType' ),
              leaf : true
            },
            {
              propertyName : 'fireAt',
              propertyType : 'Object',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzNthIncludedDayTrigger.fireAt' ),
              leaf : true
            },
            {
              propertyName : 'timeZone',
              propertyType : 'Object',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzNthIncludedDayTrigger.timeZone' ),
              leaf : true
            },
            {
              propertyName : 'nextFireCutoffInterval',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzNthIncludedDayTrigger.nextFireCutoffInterval' ),
              leaf : true
            }
          ]
        },


        /* QuartzSimpleTrigger */
        {
          propertyName : 'QuartzSimpleTrigger',
          propertyType : 'Object',
          description : QDesk.Msg.get(
              'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzSimpleTrigger' ),
          leaf : false,
          children : [
            {
              propertyName : 'repeatCount',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzSimpleTrigger.repeatCount' ),
              leaf : true
            },
            {
              propertyName : 'repeatInterval',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzSimpleTrigger.repeatInterval' ),
              leaf : true
            }
          ]
        },


        /* QuartzTrigger */
        {
          propertyName : 'QuartzTrigger',
          propertyType : 'Object',
          description : QDesk.Msg.get(
              'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzTrigger' ),
          leaf : false,
          children : [
            {
              propertyName : 'name',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzTrigger.name' ),
              leaf : true
            },
            {
              propertyName : 'groupName',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzTrigger.groupName' ),
              leaf : true
            },
            {
              propertyName : 'type',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzTrigger.type' ),
              leaf : true
            },
            {
              propertyName : 'state',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzTrigger.state' ),
              leaf : true
            },
            {
              propertyName : 'jobName',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzTrigger.jobName' ),
              leaf : true
            },
            {
              propertyName : 'jobGroupName',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzTrigger.jobGroupName' ),
              leaf : true
            },
            {
              propertyName : 'calendar',
              propertyType : 'Object',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzTrigger.calendar' ),
              leaf : true
            },
            {
              propertyName : 'description',
              propertyType : 'String',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzTrigger.description' ),
              leaf : true
            },
            {
              propertyName : 'priority',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzTrigger.priority' ),
              leaf : true
            },
            {
              propertyName : 'misfireInstruction',
              propertyType : 'Number',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzTrigger.misfireInstruction' ),
              leaf : true
            },
            {
              propertyName : 'startTime',
              propertyType : 'Date',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzTrigger.startTime' ),
              leaf : true
            },
            {
              propertyName : 'endTime',
              propertyType : 'Date',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzTrigger.endTime' ),
              leaf : true
            },
            {
              propertyName : 'previousFireTime',
              propertyType : 'Date',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzTrigger.previousFireTime' ),
              leaf : true
            },
            {
              propertyName : 'nextFireTime',
              propertyType : 'Date',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzTrigger.nextFireTime' ),
              leaf : true
            },
            {
              propertyName : 'finalFireTime',
              propertyType : 'Date',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzTrigger.finalFireTime' ),
              leaf : true
            },
            {
              propertyName : 'jobDataMap',
              propertyType : 'Array',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzTrigger.jobDataMap' ),
              leaf : true
            },
            {
              propertyName : 'mergedJobDataMap',
              propertyType : 'Array',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzTrigger.mergedJobDataMap' ),
              leaf : true
            },
            {
              propertyName : 'volatility',
              propertyType : 'Boolean',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzTrigger.volatility' ),
              leaf : true
            },
            // {
            //   propertyName : 'monitoringUrl',
            //   propertyType : 'String',
            //   description : QDesk.Msg.get(
            //       'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzTrigger.monitoringUrl' ),
            //   leaf : true
            // },
            {
              propertyName : 'execHealthIndicator',
              propertyType : 'Array',
              description : QDesk.Msg.get(
                  'QDesk.store.scheduler.quartz.QuartzJSScriptingDataTypesTreeStore.QuartzTrigger.execHealthIndicator' ),
              leaf : true
            }
          ]
        }
      ]
    };

    Ext.apply( config, {
      root : root
    } );

    me.callParent( [ config ] );
  }
} )
;
