/*
 * Copyright (c) 2013-2018 QuartzDesk.com. All Rights Reserved.
 * QuartzDesk.com PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

//
// MD5 implementation code copied from http://www.myersdaily.org/joseph/javascript/md5-text.html
//
Ext.define( 'QDesk.util.MD5', {
  requires : [],

  singleton : true,

  HEX_CHR : '0123456789abcdef'.split( '' ),


  /**
   * Returns the MD5 hash of the specified string.
   * @param s a string.
   * @returns {*} the MD5 hash.
   */
  md5 : function ( s )
  {
    return QDesk.util.MD5._hex( QDesk.util.MD5._md51( s ) );
  },


  /**
   * @private
   */
  _md5cycle : function ( x, k )
  {
    var a = x[ 0 ], b = x[ 1 ], c = x[ 2 ], d = x[ 3 ];

    a = QDesk.util.MD5._ff( a, b, c, d, k[ 0 ], 7, -680876936 );
    d = QDesk.util.MD5._ff( d, a, b, c, k[ 1 ], 12, -389564586 );
    c = QDesk.util.MD5._ff( c, d, a, b, k[ 2 ], 17, 606105819 );
    b = QDesk.util.MD5._ff( b, c, d, a, k[ 3 ], 22, -1044525330 );
    a = QDesk.util.MD5._ff( a, b, c, d, k[ 4 ], 7, -176418897 );
    d = QDesk.util.MD5._ff( d, a, b, c, k[ 5 ], 12, 1200080426 );
    c = QDesk.util.MD5._ff( c, d, a, b, k[ 6 ], 17, -1473231341 );
    b = QDesk.util.MD5._ff( b, c, d, a, k[ 7 ], 22, -45705983 );
    a = QDesk.util.MD5._ff( a, b, c, d, k[ 8 ], 7, 1770035416 );
    d = QDesk.util.MD5._ff( d, a, b, c, k[ 9 ], 12, -1958414417 );
    c = QDesk.util.MD5._ff( c, d, a, b, k[ 10 ], 17, -42063 );
    b = QDesk.util.MD5._ff( b, c, d, a, k[ 11 ], 22, -1990404162 );
    a = QDesk.util.MD5._ff( a, b, c, d, k[ 12 ], 7, 1804603682 );
    d = QDesk.util.MD5._ff( d, a, b, c, k[ 13 ], 12, -40341101 );
    c = QDesk.util.MD5._ff( c, d, a, b, k[ 14 ], 17, -1502002290 );
    b = QDesk.util.MD5._ff( b, c, d, a, k[ 15 ], 22, 1236535329 );

    a = QDesk.util.MD5._gg( a, b, c, d, k[ 1 ], 5, -165796510 );
    d = QDesk.util.MD5._gg( d, a, b, c, k[ 6 ], 9, -1069501632 );
    c = QDesk.util.MD5._gg( c, d, a, b, k[ 11 ], 14, 643717713 );
    b = QDesk.util.MD5._gg( b, c, d, a, k[ 0 ], 20, -373897302 );
    a = QDesk.util.MD5._gg( a, b, c, d, k[ 5 ], 5, -701558691 );
    d = QDesk.util.MD5._gg( d, a, b, c, k[ 10 ], 9, 38016083 );
    c = QDesk.util.MD5._gg( c, d, a, b, k[ 15 ], 14, -660478335 );
    b = QDesk.util.MD5._gg( b, c, d, a, k[ 4 ], 20, -405537848 );
    a = QDesk.util.MD5._gg( a, b, c, d, k[ 9 ], 5, 568446438 );
    d = QDesk.util.MD5._gg( d, a, b, c, k[ 14 ], 9, -1019803690 );
    c = QDesk.util.MD5._gg( c, d, a, b, k[ 3 ], 14, -187363961 );
    b = QDesk.util.MD5._gg( b, c, d, a, k[ 8 ], 20, 1163531501 );
    a = QDesk.util.MD5._gg( a, b, c, d, k[ 13 ], 5, -1444681467 );
    d = QDesk.util.MD5._gg( d, a, b, c, k[ 2 ], 9, -51403784 );
    c = QDesk.util.MD5._gg( c, d, a, b, k[ 7 ], 14, 1735328473 );
    b = QDesk.util.MD5._gg( b, c, d, a, k[ 12 ], 20, -1926607734 );

    a = QDesk.util.MD5._hh( a, b, c, d, k[ 5 ], 4, -378558 );
    d = QDesk.util.MD5._hh( d, a, b, c, k[ 8 ], 11, -2022574463 );
    c = QDesk.util.MD5._hh( c, d, a, b, k[ 11 ], 16, 1839030562 );
    b = QDesk.util.MD5._hh( b, c, d, a, k[ 14 ], 23, -35309556 );
    a = QDesk.util.MD5._hh( a, b, c, d, k[ 1 ], 4, -1530992060 );
    d = QDesk.util.MD5._hh( d, a, b, c, k[ 4 ], 11, 1272893353 );
    c = QDesk.util.MD5._hh( c, d, a, b, k[ 7 ], 16, -155497632 );
    b = QDesk.util.MD5._hh( b, c, d, a, k[ 10 ], 23, -1094730640 );
    a = QDesk.util.MD5._hh( a, b, c, d, k[ 13 ], 4, 681279174 );
    d = QDesk.util.MD5._hh( d, a, b, c, k[ 0 ], 11, -358537222 );
    c = QDesk.util.MD5._hh( c, d, a, b, k[ 3 ], 16, -722521979 );
    b = QDesk.util.MD5._hh( b, c, d, a, k[ 6 ], 23, 76029189 );
    a = QDesk.util.MD5._hh( a, b, c, d, k[ 9 ], 4, -640364487 );
    d = QDesk.util.MD5._hh( d, a, b, c, k[ 12 ], 11, -421815835 );
    c = QDesk.util.MD5._hh( c, d, a, b, k[ 15 ], 16, 530742520 );
    b = QDesk.util.MD5._hh( b, c, d, a, k[ 2 ], 23, -995338651 );

    a = QDesk.util.MD5._ii( a, b, c, d, k[ 0 ], 6, -198630844 );
    d = QDesk.util.MD5._ii( d, a, b, c, k[ 7 ], 10, 1126891415 );
    c = QDesk.util.MD5._ii( c, d, a, b, k[ 14 ], 15, -1416354905 );
    b = QDesk.util.MD5._ii( b, c, d, a, k[ 5 ], 21, -57434055 );
    a = QDesk.util.MD5._ii( a, b, c, d, k[ 12 ], 6, 1700485571 );
    d = QDesk.util.MD5._ii( d, a, b, c, k[ 3 ], 10, -1894986606 );
    c = QDesk.util.MD5._ii( c, d, a, b, k[ 10 ], 15, -1051523 );
    b = QDesk.util.MD5._ii( b, c, d, a, k[ 1 ], 21, -2054922799 );
    a = QDesk.util.MD5._ii( a, b, c, d, k[ 8 ], 6, 1873313359 );
    d = QDesk.util.MD5._ii( d, a, b, c, k[ 15 ], 10, -30611744 );
    c = QDesk.util.MD5._ii( c, d, a, b, k[ 6 ], 15, -1560198380 );
    b = QDesk.util.MD5._ii( b, c, d, a, k[ 13 ], 21, 1309151649 );
    a = QDesk.util.MD5._ii( a, b, c, d, k[ 4 ], 6, -145523070 );
    d = QDesk.util.MD5._ii( d, a, b, c, k[ 11 ], 10, -1120210379 );
    c = QDesk.util.MD5._ii( c, d, a, b, k[ 2 ], 15, 718787259 );
    b = QDesk.util.MD5._ii( b, c, d, a, k[ 9 ], 21, -343485551 );

    x[ 0 ] = QDesk.util.MD5._add32( a, x[ 0 ] );
    x[ 1 ] = QDesk.util.MD5._add32( b, x[ 1 ] );
    x[ 2 ] = QDesk.util.MD5._add32( c, x[ 2 ] );
    x[ 3 ] = QDesk.util.MD5._add32( d, x[ 3 ] );
  },


  /**
   * @private
   */
  _cmn : function ( q, a, b, x, s, t )
  {
    a = QDesk.util.MD5._add32( QDesk.util.MD5._add32( a, q ), QDesk.util.MD5._add32( x, t ) );
    return QDesk.util.MD5._add32( (a << s) | (a >>> (32 - s)), b );
  },


  /**
   * @private
   */
  _ff : function ( a, b, c, d, x, s, t )
  {
    return QDesk.util.MD5._cmn( (b & c) | ((~b) & d), a, b, x, s, t );
  },


  /**
   * @private
   */
  _gg : function ( a, b, c, d, x, s, t )
  {
    return QDesk.util.MD5._cmn( (b & d) | (c & (~d)), a, b, x, s, t );
  },


  /**
   * @private
   */
  _hh : function ( a, b, c, d, x, s, t )
  {
    return QDesk.util.MD5._cmn( b ^ c ^ d, a, b, x, s, t );
  },


  /**
   * @private
   */
  _ii : function ( a, b, c, d, x, s, t )
  {
    return QDesk.util.MD5._cmn( c ^ (b | (~d)), a, b, x, s, t );
  },


  /**
   * @private
   */
  _md51 : function ( s )
  {
    txt = '';
    var n = s.length,
        state = [ 1732584193, -271733879, -1732584194, 271733878 ], i;
    for ( i = 64; i <= s.length; i += 64 )
    {
      QDesk.util.MD5._md5cycle( state, QDesk.util.MD5._md5blk( s.substring( i - 64, i ) ) );
    }
    s = s.substring( i - 64 );
    var tail = [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ];
    for ( i = 0; i < s.length; i++ )
      tail[ i >> 2 ] |= s.charCodeAt( i ) << ((i % 4) << 3);
    tail[ i >> 2 ] |= 0x80 << ((i % 4) << 3);
    if ( i > 55 )
    {
      QDesk.util.MD5._md5cycle( state, tail );
      for ( i = 0; i < 16; i++ ) tail[ i ] = 0;
    }
    tail[ 14 ] = n * 8;
    QDesk.util.MD5._md5cycle( state, tail );
    return state;
  },


  /* there needs to be support for Unicode here,
   * unless we pretend that we can redefine the MD-5
   * algorithm for multi-byte characters (perhaps
   * by adding every four 16-bit characters and
   * shortening the sum to 32 bits). Otherwise
   * I suggest performing MD-5 as if every character
   * was two bytes--e.g., 0040 0025 = @%--but then
   * how will an ordinary MD-5 sum be matched?
   * There is no way to standardize text to something
   * like UTF-8 before transformation; speed cost is
   * utterly prohibitive. The JavaScript standard
   * itself needs to look at this: it should start
   * providing access to strings as preformed UTF-8
   * 8-bit unsigned value arrays.
   */

  /**
   * @private
   */
  _md5blk : function ( s )
  { /* I figured global was faster.   */
    var md5blks = [], i;
    /* Andy King said do it this way. */
    for ( i = 0; i < 64; i += 4 )
    {
      md5blks[ i >> 2 ] = s.charCodeAt( i )
          + (s.charCodeAt( i + 1 ) << 8)
          + (s.charCodeAt( i + 2 ) << 16)
          + (s.charCodeAt( i + 3 ) << 24);
    }
    return md5blks;
  },


  /**
   * @private
   */
  _rhex : function ( n )
  {
    var s = '', j = 0;
    for ( ; j < 4; j++ )
      s += QDesk.util.MD5.HEX_CHR[ (n >> (j * 8 + 4)) & 0x0F ]
          + QDesk.util.MD5.HEX_CHR[ (n >> (j * 8)) & 0x0F ];
    return s;
  },


  /**
   * @private
   */
  _hex : function ( x )
  {
    for ( var i = 0; i < x.length; i++ )
      x[ i ] = QDesk.util.MD5._rhex( x[ i ] );
    return x.join( '' );
  },


  /* this function is much faster,
   so if possible we use it. Some IEs
   are the only ones I know of that
   need the idiotic second function,
   generated by an if clause.  */

  /**
   * @private
   */
  _add32 : function ( a, b )
  {
    return (a + b) & 0xFFFFFFFF;
  }

  // if (QDesk.util.MD5.md5('hello') != '5d41402abc4b2a76b9719d911017c592')
  // {
  //   add32 : function(x, y)
  //   {
  //     var lsw = (x & 0xFFFF) + (y & 0xFFFF),
  //     msw = (x >> 16) + (y >> 16) + (lsw >> 16);
  //     return (msw << 16) | (lsw & 0xFFFF);
  //   }
  // }
} );
