/*
 * Copyright (c) 2013-2018 QuartzDesk.com. All Rights Reserved.
 * QuartzDesk.com PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

Ext.define( 'QDesk.view.about.AboutWindow', {
  extend : 'Ext.window.Window',

  requires : [
    'QDesk.view.about.AboutForm',
    'QDesk.Msg'
  ],

  alias : 'widget.AboutWindow',

  cls : 'aboutWindow',

  modal : true,
  resizable : false,

  header : false,

  width : 600,

  items : [
    {
      xtype : 'AboutForm',
      itemId : 'aboutForm',
      // top padding for the QuartzDesk logo
      padding : '100 0 0 0'
    }
  ],

  constructor : function ( config )
  {
    var me = this;

    config = config || {};
    me.callParent( [ config ] );
  },


  initComponent : function ()
  {
    var me = this;
    me.callParent();

    me.on( 'afterrender', function ()
    {
      me.getEl().on( 'click', function ( event, target )
      {
        if ( target.tagName.toLowerCase() == 'a' )
        {
          // if a link was clicked, let the even bubble up as that causes the window to be closed
        }
        else
        {
          event.stopPropagation();
        }
      } )
    } );
  }
} );
