/*
 * Copyright (c) 2013-2018 QuartzDesk.com. All Rights Reserved.
 * QuartzDesk.com PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

Ext.define( 'QDesk.view.security.ForgotPasswordForm', {
  extend : 'QDesk.view.base.BaseFormPanel',

  requires : [
    'QDesk.Msg',

    'QDesk.view.base.BaseFormPanel'
  ],

  alias : 'widget.ForgotPasswordForm',

  border : false,

  buttonAlign : 'center',

  fieldDefaults : {
    labelAlign : 'top'
  },

  defaultButton : 'resetPasswordButton',


  constructor : function ( config )
  {
    var me = this;

    config = config || {};

    Ext.apply( config, {
      items : [
        {
          xtype : 'container',
          layout : {
            type : 'column'
          },
          items : [
            {
              xtype : 'displayfield',
              cls : 'usernameIcon',
              margin : '20 0 0 0'
            },
            {
              xtype : 'textfield',
              itemId : 'username',
              name : 'username',
              fieldLabel : QDesk.Msg.get( 'QDesk.view.security.ForgotPasswordForm.fieldLabelUsername' ),
              fieldTooltip : QDesk.Msg.get( 'QDesk.view.security.ForgotPasswordForm.fieldTooltipUsername' ),
              emptyText : QDesk.Msg.get( 'QDesk.view.security.ForgotPasswordForm.fieldEmptyTxtUsername' ),
              allowBlank : false,
              margin : '0 20 0 10',
              columnWidth : 1
            }
          ]
        }
      ],

      buttons : [
        {
          itemId : 'resetPasswordButton',
          reference : 'resetPasswordButton', /* required for the defaultButton to work */
          text : QDesk.Msg.get( 'QDesk.view.security.ForgotPasswordForm.buttonLabelResetPassword' ),
          formBind : true
        }
      ]
    } );

    me.callParent( [ config ] );
  }
} );
