/*
 * Copyright (c) 2013-2018 QuartzDesk.com. All Rights Reserved.
 * QuartzDesk.com PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

Ext.define( 'QDesk.view.security.LoginForm', {
  extend : 'QDesk.view.base.BaseFormPanel',

  requires : [
    'QDesk.Msg',

    'QDesk.view.base.BaseFormPanel'
  ],

  alias : 'widget.LoginForm',

  border : false,

  buttonAlign : 'center',

  fieldDefaults : {
    labelAlign : 'top'
  },

  defaultButton : 'loginButton',


  constructor : function ( config )
  {
    var me = this;

    config = config || {};

    Ext.apply( config, {
      items : [
        {
          xtype : 'container',
          layout : {
            type : 'hbox',
            align : 'end',
            pack : 'left'
          },
          items : [
            {
              xtype : 'displayfield',
              cls : 'usernameIcon'
            },
            {
              xtype : 'textfield',
              itemId : 'username',
              name : 'username',
              fieldLabel : QDesk.Msg.get( 'QDesk.view.security.LoginForm.fieldLabelUsername' ),
              fieldTooltip : QDesk.Msg.get( 'QDesk.view.security.LoginForm.fieldTooltipUsername' ),
              emptyText : QDesk.Msg.get( 'QDesk.view.security.LoginForm.fieldEmptyTxtUsername' ),
              allowBlank : false,
              msgTarget : 'none',
              flex : 1,
              margin : '0 20 0 10'
            }
          ]
        },

        {
          xtype : 'container',
          layout : {
            type : 'hbox',
            align : 'end',
            pack : 'left'
          },
          items : [
            {
              xtype : 'displayfield',
              cls : 'passwordIcon'
            },
            {
              xtype : 'textfield',
              itemId : 'password',
              name : 'password',
              fieldLabel : QDesk.Msg.get( 'QDesk.view.security.LoginForm.fieldLabelPassword' ),
              fieldTooltip : QDesk.Msg.get( 'QDesk.view.security.LoginForm.fieldTooltipPassword' ),
              emptyText : QDesk.Msg.get( 'QDesk.view.security.LoginForm.fieldEmptyTxtPassword' ),
              allowBlank : false,
              inputType : 'password',
              msgTarget : 'none',
              flex : 1,
              margin : '0 20 0 10'
            }
          ]
        }
      ],

      buttons : [
        {
          itemId : 'loginButton',
          reference : 'loginButton', /* required for the defaultButton to work */
          text : QDesk.Msg.get( 'QDesk.view.security.LoginForm.buttonLabelLogin' ),
          formBind : true
        }
      ]
    } );

    me.callParent( [ config ] );
  }
} );
