/*
 * Copyright (c) 2013-2018 QuartzDesk.com. All Rights Reserved.
 * QuartzDesk.com PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

/**
 * Panel with a form that allows a user to log in.
 */
Ext.define( 'QDesk.view.security.LoginPanel', {
  extend : 'Ext.panel.Panel',

  requires : [
    'QDesk.util.license.LicensedProduct',
    'QDesk.view.security.LoginForm',

    'QDesk.controller.command.security.Login'
  ],

  alias : 'widget.LoginPanel',

  border : false,

  // cls : 'loginPanel',

  layout : {
    type : 'vbox',
    align : 'stretch',
    pack : 'center'
  },


  constructor : function ( config )
  {
    var me = this;

    config = config || {};

    Ext.apply( config, {
      items : [
        {
          xtype : 'LoginForm'
        },
        {
          xtype : 'panel',
          border : false,
          itemId : 'navigationLinks',
          layout : {
            type : 'hbox',
            align : 'stretch',
            pack : 'center'
          },
          items : [
            // {
            //   xtype : 'displayfield',
            //   cls : 'link',
            //   itemId : 'forgotUsernameLink',
            //   value : QDesk.Msg.get( 'QDesk.view.security.LoginPanel.forgotUsernameLink' ),
            //   margin : '0 10 0 10'
            // },
            // {
            //   xtype : 'displayfield',
            //   cls : 'link',
            //   itemId : 'forgotPasswordLink',
            //   value : QDesk.Msg.get( 'QDesk.view.security.LoginPanel.forgotPasswordLink' ),
            //   margin : '0 10 0 10'
            // }
          ]
        }
      ]
    } );

    me.callParent( [ config ] );

    me._bindEventHandlers();
  },


  /**
   * Binds event handlers.
   */
  _bindEventHandlers : function ()
  {
    var me = this;

    me.on( 'activate', function ()
    {
      var usernameField = me.down( '#username' );
      QDesk.util.UxUtils.focus( usernameField, false );

      return true;
    } );


    /*
     * Add click events to all links in the navigationLinks panel. These are not HTML links and as such they
     * do not fire click events when clicked.
     */
    Ext.each( Ext.ComponentQuery.query( '#navigationLinks > displayfield[cls=link]', me ),
        function ( link )
        {
          link.on( 'afterrender', function ()
          {
            link.getEl().on( 'click', function ()
            {
              link.fireEvent( 'click' );
            } );
          } );
        } );


    me.down( '#loginButton' ).on( 'click', function ()
    {
      var username = me.down( '#username' ).getValue();
      var password = me.down( '#password' ).getValue();

      Ext.create( 'QDesk.controller.command.security.Login', {
        username : username,
        password : password
      } ).execute();
    } );


    // me.down( '#forgotUsernameLink' ).on( 'click', function ()
    // {
    //   var securityPanel = me.up( '#securityPanel' );
    //   securityPanel.activateForgotUsernamePanel();
    // } );
    //
    // me.down( '#forgotPasswordLink' ).on( 'click', function ()
    // {
    //   var securityPanel = me.up( '#securityPanel' );
    //   securityPanel.activateForgotPasswordPanel();
    // } );
  }
} );
