/*
 * Copyright (c) 2013-2018 QuartzDesk.com. All Rights Reserved.
 * QuartzDesk.com PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

/*
 * Execution Health Indicator widget based on the standard sparklinetristate widget.
 */
Ext.define( 'QDesk.view.widget.WExecHealthIndicator', {
  extend : 'Ext.sparkline.TriState',

  requires : [
    'QDesk.Msg',

    'QDesk.model.scheduler.ExecStatus',

    'QDesk.util.EnumUtils',
    'QDesk.util.FormatUtils'
  ],

  alias : 'widget.WExecHealthIndicator',

  barSpacing : 2,
  barWidth : 8,
  posBarColor : '#2DBD1D', /* SUCCESS */
  negBarColor : '#BD1D2D', /* ERROR */
  zeroBarColor : '#D3901A', /* VETO */
  tooltipSkipNull : false,
  tipTpl : new Ext.XTemplate( '{value:this.formatValue}',
      {
        formatValue : function ( v )
        {
          if ( v == 0 || v == null )  // it seems that null is never passed in; when data is null we get 0 instead (!!!)
          {
            return '<strong>' +
                QDesk.Msg.get( 'QDesk.view.widget.WExecHealthIndicator.status' ) +
                ':</strong> ' +
                QDesk.util.EnumUtils.getExecStatusName( QDesk.model.scheduler.ExecStatus.VETO );
          }
          else
          {
            var value = Number( v );
            if ( value < 0 )
            {
              return '<strong>' +
                  QDesk.Msg.get( 'QDesk.view.widget.WExecHealthIndicator.status' ) +
                  ':</strong> ' +
                  QDesk.util.EnumUtils.getExecStatusName( QDesk.model.scheduler.ExecStatus.ERROR ) +
                  '<br/><strong>' + QDesk.Msg.get( 'QDesk.view.widget.WExecHealthIndicator.duration' ) +
                  ':</strong> ' + QDesk.util.FormatUtils.formatDuration( -value );
            }
            else if ( value > 0 )
            {
              return '<strong>' +
                  QDesk.Msg.get( 'QDesk.view.widget.WExecHealthIndicator.status' ) +
                  ':</strong> ' +
                  QDesk.util.EnumUtils.getExecStatusName( QDesk.model.scheduler.ExecStatus.SUCCESS ) +
                  '<br/><strong>' + QDesk.Msg.get( 'QDesk.view.widget.WExecHealthIndicator.duration' ) +
                  ':</strong> ' + QDesk.util.FormatUtils.formatDuration( value );
            }
          }
        }
      } )
} );
