/*
 * Copyright (c) 2013-2018 QuartzDesk.com. All Rights Reserved.
 * QuartzDesk.com PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

Ext.define( 'QDesk.view.work.ViewLogWindow', {
  extend : 'Ext.window.Window',

  requires : [
    'QDesk.Msg'
  ],

  alias : 'widget.ViewLogWindow',

  cls : 'viewLogWindow',
  iconCls : 'windowIcon',

  scrollable : true,

  modal : true,
  resizable : true,
  maximizable : true,

  width : 800,
  height : 500,

  minWidth : 800,
  minHeight : 500,

  layout : 'fit',

  constructor : function ( config )
  {
    var me = this;

    config = config || {};

    Ext.apply( config, {
      title : QDesk.Msg.get( 'QDesk.view.work.ViewLogWindow.windowTitle' ),

      items : [
        {
          xtype : 'panel',
          itemId : 'viewPanel',
          scrollable : true,
          style : {
            background : 'white'
          }
        }
      ],

      dockedItems : [
        {
          xtype : 'toolbar',
          dock : 'top',
          //ui : 'footer',
          items : [
            {
              xtype : 'button',
              itemId : 'saveButton',
              scale : 'small',
              iconCls : 'save',
              tooltip : QDesk.Msg.get( 'QDesk.view.work.ViewLogWindow.tooltipSaveButton' ),
              disabled : true
            },
            {
              xtype : 'button',
              itemId : 'autoScrollButton',
              scale : 'small',
              iconCls : 'autoScroll',
              pressed : false,
              enableToggle : true,
              tooltip : QDesk.Msg.get( 'QDesk.view.work.ViewLogWindow.tooltipAutoScrollButton' ),
              disabled : true
            },
            '-',
            {
              xtype : 'button',
              itemId : 'interruptJobButton',
              scale : 'small',
              iconCls : 'quartzInterruptJob',
              pressed : false,
              enableToggle : true,
              tooltip : QDesk.Msg.get( 'QDesk.view.work.ViewLogWindow.tooltipInterruptJobButton' ),
              disabled : true
            }
          ]
        },
        {
          xtype : 'toolbar',
          dock : 'bottom',
          ui : 'footer',
          defaults : {
            minWidth : 75
          },
          items : [
            {
              xtype : 'component',
              flex : 1
            },
            {
              xtype : 'button',
              itemId : 'closeButton',
              text : QDesk.Msg.get( 'QDesk.buttonLabelClose' )
            }
          ]
        }
      ]
    } );

    me.callParent( [ config ] );

    me.down( '#closeButton' ).on( 'click', function ()
    {
      me.close();
    } );
  }
} );
