/*
 * Copyright (c) 2013-2018 QuartzDesk.com. All Rights Reserved.
 * QuartzDesk.com PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

Ext.define( 'QDesk.view.work.config.confirm.QuartzConfirmationsPanel', {
  extend : 'QDesk.view.base.BaseConfigFormPanel',

  requires : [
    'QDesk.Msg'
  ],

  alias : 'widget.QuartzConfirmationsPanel',

  constructor : function ( config )
  {
    var me = this;

    config = config || {};

    Ext.apply( config, {
      items : [
        /* Jobs confirmations */
        {
          xtype : 'fieldset',
          title : QDesk.Msg.get( 'QDesk.view.work.config.confirm.QuartzConfirmationsPanel.fieldsetLabelJobs' ),
          items : [
            {
              xtype : 'checkboxfield',
              name : 'quartz.confirm.jobDelete',
              boxLabel : QDesk.Msg.get(
                  'QDesk.view.work.config.confirm.QuartzConfirmationsPanel.boxLabelConfirmJobDelete' ),
              boxTooltip : QDesk.Msg.get(
                  'QDesk.view.work.config.confirm.QuartzConfirmationsPanel.boxTooltipConfirmJobDelete' )
            },
            {
              xtype : 'checkboxfield',
              name : 'quartz.confirm.jobInterrupt',
              boxLabel : QDesk.Msg.get(
                  'QDesk.view.work.config.confirm.QuartzConfirmationsPanel.boxLabelConfirmJobInterrupt' ),
              boxTooltip : QDesk.Msg.get(
                  'QDesk.view.work.config.confirm.QuartzConfirmationsPanel.boxTooltipConfirmJobInterrupt' )
            },
            {
              xtype : 'checkboxfield',
              name : 'quartz.confirm.jobGroupResume',
              boxLabel : QDesk.Msg.get(
                  'QDesk.view.work.config.confirm.QuartzConfirmationsPanel.boxLabelConfirmJobGroupResume' ),
              boxTooltip : QDesk.Msg.get(
                  'QDesk.view.work.config.confirm.QuartzConfirmationsPanel.boxTooltipConfirmJobGroupResume' )
            },
            {
              xtype : 'checkboxfield',
              name : 'quartz.confirm.jobGroupPause',
              boxLabel : QDesk.Msg.get(
                  'QDesk.view.work.config.confirm.QuartzConfirmationsPanel.boxLabelConfirmJobGroupPause' ),
              boxTooltip : QDesk.Msg.get(
                  'QDesk.view.work.config.confirm.QuartzConfirmationsPanel.boxTooltipConfirmJobGroupPause' )
            }
          ],
          qdesk : {
            licensedFor : [
              QDesk.model.license.ProductEdition.LITE,
              QDesk.model.license.ProductEdition.STANDARD,
              QDesk.model.license.ProductEdition.ENTERPRISE
            ]
          }
        },


        /* Triggers confirmations */
        {
          xtype : 'fieldset',
          title : QDesk.Msg.get( 'QDesk.view.work.config.confirm.QuartzConfirmationsPanel.fieldsetLabelTriggers' ),
          items : [
            {
              xtype : 'checkboxfield',
              name : 'quartz.confirm.triggerDelete',
              boxLabel : QDesk.Msg.get(
                  'QDesk.view.work.config.confirm.QuartzConfirmationsPanel.boxLabelConfirmTriggerDelete' ),
              boxTooltip : QDesk.Msg.get(
                  'QDesk.view.work.config.confirm.QuartzConfirmationsPanel.boxTooltipConfirmTriggerDelete' )
            },
            {
              xtype : 'checkboxfield',
              name : 'quartz.confirm.triggerResume',
              boxLabel : QDesk.Msg.get(
                  'QDesk.view.work.config.confirm.QuartzConfirmationsPanel.boxLabelConfirmTriggerResume' ),
              boxTooltip : QDesk.Msg.get(
                  'QDesk.view.work.config.confirm.QuartzConfirmationsPanel.boxTooltipConfirmTriggerResume' )
            },
            {
              xtype : 'checkboxfield',
              name : 'quartz.confirm.triggerPause',
              boxLabel : QDesk.Msg.get(
                  'QDesk.view.work.config.confirm.QuartzConfirmationsPanel.boxLabelConfirmTriggerPause' ),
              boxTooltip : QDesk.Msg.get(
                  'QDesk.view.work.config.confirm.QuartzConfirmationsPanel.boxTooltipConfirmTriggerPause' )
            },
            {
              xtype : 'checkboxfield',
              name : 'quartz.confirm.triggerGroupResume',
              boxLabel : QDesk.Msg.get(
                  'QDesk.view.work.config.confirm.QuartzConfirmationsPanel.boxLabelConfirmTriggerGroupResume' ),
              boxTooltip : QDesk.Msg.get(
                  'QDesk.view.work.config.confirm.QuartzConfirmationsPanel.boxTooltipConfirmTriggerGroupResume' )
            },
            {
              xtype : 'checkboxfield',
              name : 'quartz.confirm.triggerGroupPause',
              boxLabel : QDesk.Msg.get(
                  'QDesk.view.work.config.confirm.QuartzConfirmationsPanel.boxLabelConfirmTriggerGroupPause' ),
              boxTooltip : QDesk.Msg.get(
                  'QDesk.view.work.config.confirm.QuartzConfirmationsPanel.boxTooltipConfirmTriggerGroupPause' )
            }
          ],
          qdesk : {
            licensedFor : [
              QDesk.model.license.ProductEdition.LITE,
              QDesk.model.license.ProductEdition.STANDARD,
              QDesk.model.license.ProductEdition.ENTERPRISE
            ]
          }
        },


        /* Exec notification rules confirmations */
        {
          xtype : 'fieldset',
          title : QDesk.Msg.get(
              'QDesk.view.work.config.confirm.QuartzConfirmationsPanel.fieldsetLabelExecNotificationRules' ),
          items : [
            {
              xtype : 'checkboxfield',
              name : 'quartz.confirm.execNotificationRuleEnable',
              boxLabel : QDesk.Msg.get(
                  'QDesk.view.work.config.confirm.QuartzConfirmationsPanel.boxLabelExecNotificationRuleEnable' ),
              boxTooltip : QDesk.Msg.get(
                  'QDesk.view.work.config.confirm.QuartzConfirmationsPanel.boxTooltipExecNotificationRuleEnable' )
            },
            {
              xtype : 'checkboxfield',
              name : 'quartz.confirm.execNotificationRuleDisable',
              boxLabel : QDesk.Msg.get(
                  'QDesk.view.work.config.confirm.QuartzConfirmationsPanel.boxLabelExecNotificationRuleDisable' ),
              boxTooltip : QDesk.Msg.get(
                  'QDesk.view.work.config.confirm.QuartzConfirmationsPanel.boxTooltipExecNotificationRuleDisable' )
            },
            {
              xtype : 'checkboxfield',
              name : 'quartz.confirm.execNotificationRuleDelete',
              boxLabel : QDesk.Msg.get(
                  'QDesk.view.work.config.confirm.QuartzConfirmationsPanel.boxLabelExecNotificationRuleDelete' ),
              boxTooltip : QDesk.Msg.get(
                  'QDesk.view.work.config.confirm.QuartzConfirmationsPanel.boxTooltipExecNotificationRuleDelete' )
            }
          ],
          qdesk : {
            licensedFor : [
              QDesk.model.license.ProductEdition.ENTERPRISE
            ]
          }
        },


        /* Job chains confirmations */
        {
          xtype : 'fieldset',
          title : QDesk.Msg.get( 'QDesk.view.work.config.confirm.QuartzConfirmationsPanel.fieldsetLabelJobChains' ),
          items : [
            {
              xtype : 'checkboxfield',
              name : 'quartz.confirm.jobChainEnable',
              boxLabel : QDesk.Msg.get(
                  'QDesk.view.work.config.confirm.QuartzConfirmationsPanel.boxLabelJobChainEnable' ),
              boxTooltip : QDesk.Msg.get(
                  'QDesk.view.work.config.confirm.QuartzConfirmationsPanel.boxTooltipJobChainEnable' )
            },
            {
              xtype : 'checkboxfield',
              name : 'quartz.confirm.jobChainDisable',
              boxLabel : QDesk.Msg.get(
                  'QDesk.view.work.config.confirm.QuartzConfirmationsPanel.boxLabelJobChainDisable' ),
              boxTooltip : QDesk.Msg.get(
                  'QDesk.view.work.config.confirm.QuartzConfirmationsPanel.boxTooltipJobChainDisable' )
            },
            {
              xtype : 'checkboxfield',
              name : 'quartz.confirm.jobChainDelete',
              boxLabel : QDesk.Msg.get(
                  'QDesk.view.work.config.confirm.QuartzConfirmationsPanel.boxLabelJobChainDelete' ),
              boxTooltip : QDesk.Msg.get(
                  'QDesk.view.work.config.confirm.QuartzConfirmationsPanel.boxTooltipJobChainDelete' )
            }
          ],
          qdesk : {
            licensedFor : [
              QDesk.model.license.ProductEdition.ENTERPRISE
            ]
          }
        }
      ]
    } );

    me.callParent( [ config ] );
  }
} );
