/*
 * Copyright (c) 2013-2018 QuartzDesk.com. All Rights Reserved.
 * QuartzDesk.com PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

Ext.define( 'QDesk.view.work.config.general.GeneralPanel', {
  extend : 'QDesk.view.base.BaseConfigFormPanel',

  requires : [
    'QDesk.view.widget.WTimestampFormatCombo',

    'QDesk.Msg'
  ],

  alias : 'widget.GeneralPanel',

  constructor : function ( config )
  {
    var me = this;

    config = config || {};

    Ext.apply( config, {
      items : [
        {
          xtype : 'fieldset',
          fieldDefaults : {
            labelWidth : 110,
            width : 200
          },
          title : QDesk.Msg.get( 'QDesk.view.work.config.general.GeneralPanel.fieldsetLabelInfoMessages' ),
          items : [
            {
              xtype : 'checkboxfield',
              itemId : 'infoBubblesEnabledCheckbox',
              name : 'infoBubblesEnabled',
              boxLabel : QDesk.Msg.get( 'QDesk.view.work.config.general.GeneralPanel.boxLabelInfoBubblesEnabled' ),
              boxTooltip : QDesk.Msg.get( 'QDesk.view.work.config.general.GeneralPanel.boxTooltipInfoBubblesEnabled' )
            },

            {
              xtype : 'fieldcontainer',
              itemId : 'infoBubblesTimeoutContainer',
              layout : {
                type : 'hbox',
                align : 'left'
              },
              items : [
                {
                  xtype : 'numberfield',
                  name : 'infoBubblesTimeout',
                  fieldLabel : QDesk.Msg.get(
                      'QDesk.view.work.config.general.GeneralPanel.fieldLabelInfoBubblesTimeout' ),
                  fieldTooltip : QDesk.Msg.get(
                      'QDesk.view.work.config.general.GeneralPanel.fieldTooltipInfoBubblesTimeout' ),
                  minValue : 1,
                  maxValue : 20,
                  allowBlank : false
                },
                {
                  xtype : 'panel',
                  border : false,
                  height : 22,
                  bodyPadding : '3 0 0 5',
                  html : QDesk.Msg.get( 'QDesk.seconds' )
                }
              ]
            }
          ],
          qdesk : {
            licensedFor : [
              QDesk.model.license.ProductEdition.LITE,
              QDesk.model.license.ProductEdition.STANDARD,
              QDesk.model.license.ProductEdition.ENTERPRISE
            ]
          }
        },

        {
          xtype : 'WTimestampFormatCombo',
          name : 'timestampFormat',
          labelWidth : 120,
          formatConfig : {
            allowBlank : false,
            fieldLabel : QDesk.Msg.get( 'QDesk.view.work.config.general.GeneralPanel.fieldLabelTimestampFormat' ),
            fieldTooltip : QDesk.Msg.get( 'QDesk.view.work.config.general.GeneralPanel.fieldTooltipTimestampFormat' ),
            qdesk : {
              licensedFor : [
                QDesk.model.license.ProductEdition.LITE,
                QDesk.model.license.ProductEdition.STANDARD,
                QDesk.model.license.ProductEdition.ENTERPRISE
              ]
            }
          }
        },

        {
          xtype : 'fieldset',
          fieldDefaults : {
            labelWidth : 100,
            width : 200
          },
          title : QDesk.Msg.get( 'QDesk.view.work.config.general.GeneralPanel.fieldsetLabelJavaScript' ),
          items : [
            {
              xtype : 'fieldcontainer',
              layout : {
                type : 'hbox',
                align : 'left'
              },
              items : [
                {
                  xtype : 'numberfield',
                  name : 'ajaxTimeout',
                  fieldLabel : QDesk.Msg.get( 'QDesk.view.work.config.general.GeneralPanel.fieldLabelJsAjaxTimeout' ),
                  fieldTooltip : QDesk.Msg.get(
                      'QDesk.view.work.config.general.GeneralPanel.fieldTooltipJsAjaxTimeout' ),
                  minValue : 10,
                  allowBlank : false
                },
                {
                  xtype : 'panel',
                  border : false,
                  height : 22,
                  bodyPadding : '3 0 0 5',
                  html : QDesk.Msg.get( 'QDesk.seconds' )
                }
              ],
              qdesk : {
                licensedFor : [
                  QDesk.model.license.ProductEdition.LITE,
                  QDesk.model.license.ProductEdition.STANDARD,
                  QDesk.model.license.ProductEdition.ENTERPRISE
                ]
              }
            },

            {
              xtype : 'combo',
              name : 'jsLoggingLevel',
              fieldLabel : QDesk.Msg.get( 'QDesk.view.work.config.general.GeneralPanel.fieldLabelJsLoggingLevel' ),
              fieldTooltip : QDesk.Msg.get( 'QDesk.view.work.config.general.GeneralPanel.fieldTooltipJsLoggingLevel' ),
              displayField : 'valueLabel',
              valueField : 'value',
              editable : false,
              store : 'enums.JsLoggingLevelStore',
              allowBlank : false,
              qdesk : {
                licensedFor : [
                  QDesk.model.license.ProductEdition.LITE,
                  QDesk.model.license.ProductEdition.STANDARD,
                  QDesk.model.license.ProductEdition.ENTERPRISE
                ]
              }
            }
          ]
        }
      ]
    } );

    me.callParent( [ config ] );
  }
} );
