/*
 * Copyright (c) 2013-2018 QuartzDesk.com. All Rights Reserved.
 * QuartzDesk.com PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

Ext.define( 'QDesk.view.work.message.channel.collaboration.hipchat.HipChatBasicPanel', {
  extend : 'Ext.panel.Panel',

  requires : [
    'QDesk.ApplicationConfig',
    'QDesk.Msg',
    'QDesk.Properties'
  ],

  alias : 'widget.CollaborationHipChatBasicPanel',

  border : false,

  layout : 'anchor',

  defaults : {
    anchor : '100%',
    labelWidth : 90
  },

  constructor : function ( config )
  {
    var me = this;

    config = config || {};

    Ext.apply( config, {
      title : QDesk.Msg.get( 'QDesk.view.work.message.channel.collaboration.hipchat.HipChatBasicPanel.tabLabelBasic' ),

      items : [
        {
          xtype : 'textfield',
          itemId : 'authToken',
          name : 'authToken',
          fieldLabel : QDesk.Msg.get(
              'QDesk.view.work.message.channel.collaboration.hipchat.HipChatBasicPanel.fieldLabelAuthToken' ),
          fieldTooltip : QDesk.Msg.get(
              'QDesk.view.work.message.channel.collaboration.hipchat.HipChatBasicPanel.fieldTooltipAuthToken' ),
          emptyText : QDesk.Msg.get(
              'QDesk.view.work.message.channel.collaboration.hipchat.HipChatBasicPanel.fieldEmptyTxtAuthToken' ),
          allowBlank : false,
          qdesk : {
            required : true
          }
        },

        {
          xtype : 'textfield',
          itemId : 'room',
          name : 'room',
          fieldLabel : QDesk.Msg.get(
              'QDesk.view.work.message.channel.collaboration.hipchat.HipChatBasicPanel.fieldLabelRoom' ),
          fieldTooltip : QDesk.Msg.get(
              'QDesk.view.work.message.channel.collaboration.hipchat.HipChatBasicPanel.fieldTooltipRoom' ),
          emptyText : QDesk.Msg.get(
              'QDesk.view.work.message.channel.collaboration.hipchat.HipChatBasicPanel.fieldEmptyTxtRoom' ),
          allowBlank : false,
          qdesk : {
            required : true
          }
        },

        // message properties
        {
          xtype : 'fieldset',
          title : QDesk.Msg.get(
              'QDesk.view.work.message.channel.collaboration.hipchat.HipChatBasicPanel.fieldsetLabelMessageProperties' ),
          tooltip : QDesk.Msg.get(
              'QDesk.view.work.message.channel.collaboration.hipchat.HipChatBasicPanel.fieldsetTooltipMessageProperties' ),
          padding : '5 5 0 5',
          defaults : {
            labelWidth : 110
          },
          items : [
            {
              xtype : 'combo',
              itemId : 'messageFormat',
              name : 'messageFormat',
              fieldLabel : QDesk.Msg.get(
                  'QDesk.view.work.message.channel.collaboration.hipchat.HipChatBasicPanel.fieldLabelMessageFormat' ),
              fieldTooltip : QDesk.Msg.get(
                  'QDesk.view.work.message.channel.collaboration.hipchat.HipChatBasicPanel.fieldTooltipMessageFormat' ),
              editable : false,
              forceSelection : true,
              queryMode : 'local',
              store : new Ext.data.ArrayStore( {
                fields : [
                  'value',
                  'valueLabel'
                ],
                data : [
                  [ 'text', 'text' ],
                  [ 'html', 'html' ]
                ]
              } ),
              valueField : 'value',
              displayField : 'valueLabel',
              allowBlank : false,
              qdesk : {
                required : true
              }
            },

            {
              xtype : 'checkboxfield',
              itemId : 'replaceEolWithBrInHtml',
              name : 'replaceEolWithBrInHtml',
              boxLabel : QDesk.Msg.get(
                  'QDesk.view.work.message.channel.collaboration.hipchat.HipChatBasicPanel.boxLabelReplaceEolWithBrInHtml' ),
              boxTooltip : QDesk.Msg.get(
                  'QDesk.view.work.message.channel.collaboration.hipchat.HipChatBasicPanel.boxTooltipReplaceEolWithBrInHtml' ),
              value : false
            },

            {
              xtype : 'combo',
              itemId : 'messageColor',
              name : 'messageColor',
              fieldLabel : QDesk.Msg.get(
                  'QDesk.view.work.message.channel.collaboration.hipchat.HipChatBasicPanel.fieldLabelMessageColor' ),
              fieldTooltip : QDesk.Msg.get(
                  'QDesk.view.work.message.channel.collaboration.hipchat.HipChatBasicPanel.fieldTooltipMessageColor' ),
              editable : false,
              forceSelection : true,
              queryMode : 'local',
              store : new Ext.data.ArrayStore( {
                fields : [
                  'value',
                  'valueLabel'
                ],
                data : [
                  [ 'gray', QDesk.Msg.get(
                      'QDesk.view.work.message.channel.collaboration.hipchat.HipChatBasicPanel.fieldValueMessageColorGray' ) ],
                  [ 'green', QDesk.Msg.get(
                      'QDesk.view.work.message.channel.collaboration.hipchat.HipChatBasicPanel.fieldValueMessageColorGreen' ) ],
                  [ 'purple', QDesk.Msg.get(
                      'QDesk.view.work.message.channel.collaboration.hipchat.HipChatBasicPanel.fieldValueMessageColorPurple' ) ],
                  [ 'red', QDesk.Msg.get(
                      'QDesk.view.work.message.channel.collaboration.hipchat.HipChatBasicPanel.fieldValueMessageColorRed' ) ],
                  [ 'yellow', QDesk.Msg.get(
                      'QDesk.view.work.message.channel.collaboration.hipchat.HipChatBasicPanel.fieldValueMessageColorYellow' ) ],
                  [ 'random', QDesk.Msg.get(
                      'QDesk.view.work.message.channel.collaboration.hipchat.HipChatBasicPanel.fieldValueMessageColorRandom' ) ]
                ]
              } ),
              valueField : 'value',
              displayField : 'valueLabel',
              allowBlank : false,
              qdesk : {
                required : true
              }
            },

            {
              xtype : 'checkboxfield',
              itemId : 'notifyUsers',
              name : 'notifyUsers',
              boxLabel : QDesk.Msg.get(
                  'QDesk.view.work.message.channel.collaboration.hipchat.HipChatBasicPanel.boxLabelNotifyUsers' ),
              boxTooltip : QDesk.Msg.get(
                  'QDesk.view.work.message.channel.collaboration.hipchat.HipChatBasicPanel.boxTooltipNotifyUsers' ),
              value : false
            }
          ]
        }
      ]
    } );

    me.callParent( [ config ] );
  },


  initComponent : function ()
  {
    var me = this;

    me.callParent();

    var messageFormatCombo = me.down( '#messageFormat' );
    messageFormatCombo.on( 'change', function ( combo, newValue, oldValue )
    {
      // disable the replaceEolWithBrInHtml checkbox if the message format != html
      var replaceEolWithBrInHtmlField = me.down( '#replaceEolWithBrInHtml' );
      replaceEolWithBrInHtmlField.setDisabled( newValue != 'html' );
    } );

    /*
     * Set default values.
     */
    var messageColorCombo = me.down( '#messageColor' );
    messageColorCombo.setValue( 'yellow' );

    // set the initial message format value (fires a change even that changes status of the replaceEolWithBrInHtml checkbox
    messageFormatCombo.setValue( 'text' );
  }
} );
