/*
 * Copyright (c) 2013-2018 QuartzDesk.com. All Rights Reserved.
 * QuartzDesk.com PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

Ext.define( 'QDesk.view.work.navigation.settings.SettingsTreePanel', {
  extend : 'Ext.tree.Panel',

  requires : [
    'QDesk.Msg',
    'QDesk.model.license.ProductEdition',
    'QDesk.model.gui.SettingsTreeNode',
    'QDesk.util.license.LicensedProduct'
  ],

  alias : 'widget.SettingsTreePanel',

  cls : 'settingsTreePanel',

  //scrollable : true,

  displayField : 'name',

  useArrows : true,

  // the settings tree panel has no root node
  rootVisible : false,


  constructor : function ( config )
  {
    var me = this;

    config = config || {};

    // important to set the store before callParent as it expects the store!!!
    var store = Ext.create( 'Ext.data.TreeStore', {

      model : 'QDesk.model.gui.SettingsTreeNode',

      root : {
        expanded : true,
        children : []    // children loaded in the SettingsController when the WorkPanel gets activated
      }
    } );

    Ext.apply( config, {
      store : store
    } );

    me.callParent( [ config ] );
  }
} );
