/*
 * Copyright (c) 2013-2018 QuartzDesk.com. All Rights Reserved.
 * QuartzDesk.com PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

Ext.define( 'QDesk.view.work.scheduler.common.ClassNamesGrid', {
  extend : 'Ext.grid.Panel',

  requires : [
    'QDesk.model.common.ClassDesc'
  ],

  alias : 'widget.ClassNamesGrid',

  cls : 'classNamesGrid',
  //iconCls : 'classNamesGridIcon',

  initComponent : function ()
  {
    var me = this;

    Ext.apply( this, {
      columns : [
        {
          text : QDesk.Msg.get( 'QDesk.view.work.scheduler.common.ClassNamesGrid.textClassNameColumn' ),
          flex : 1,
          hideable : false,
          sortable : false,
          dataIndex : 'className'
        }
      ]
    } );

    me.callParent();
  },


  constructor : function ( config )
  {
    var me = this;

    config = config || {};

    var store = Ext.create( 'Ext.data.Store', {
      model : 'QDesk.model.common.ClassDesc',
      data : [],
      proxy : {
        type : 'memory',
        reader : {
          type : 'json'
          /*
           * We need to transform the string array data returned by the server onto a list of objects
           * with className attributes.
           */
          // transform : function ( data )
          // {
          //   return data.map( function ( val )
          //   {
          //     return { className : val };
          //   } );
          // }
        }
      }
    } );

    Ext.apply( config, {
      store : store
    } );

    me.callParent( [ config ] );
  }
} );