/*
 * Copyright (c) 2013-2018 QuartzDesk.com. All Rights Reserved.
 * QuartzDesk.com PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

Ext.define( 'QDesk.view.work.scheduler.common.notif.exec.ExecNotificationRuleMessageMacrosForm', {
  extend : 'QDesk.view.base.BaseFormPanel',

  requires : [
    'QDesk.Msg',
    'QDesk.view.base.BaseFormPanel',
    'QDesk.view.work.scheduler.common.notif.exec.ExecNotificationRuleMessageMacrosTreePanel'
  ],

  alias : 'widget.ExecNotificationRuleMessageMacrosForm',

  fieldDefaults : {
    labelWidth : 80
  },

  /* Override the default 10px body padding. We want 0 body padding for this particular form. */
  bodyPadding : 0,

  layout : {
    type : 'vbox',
    align : 'stretch'
  },

  qdesk : {
    /*
     * Scheduler type (see QDesk.model.scheduler.SchedulerType).
     */
    schedulerType : undefined
  },


  constructor : function ( config )
  {
    var me = this;

    config = config || {};

    if ( !config.qdesk )
      Ext.Error.raise( 'Required config parameter missing: qdesk' );

    if ( !config.qdesk.schedulerType )
      Ext.Error.raise( 'Required config parameter missing: qdesk.schedulerType' );

    Ext.apply( config, {
          items : [
            {
              xtype : 'panel',
              border : false,
              padding : 5,
              flex : 1,
              layout : {
                type : 'vbox',
                align : 'stretch'
              },
              items : [
                {
                  xtype : 'InfoMessagePanel',
                  margin : '0 0 5 0',
                  qdesk : {
                    msg : QDesk.Msg.get(
                        'QDesk.view.work.scheduler.common.notif.exec.ExecNotificationRuleMessageMacrosForm.description' )
                  }
                },
                {
                  xtype : 'ExecNotificationRuleMessageMacrosTreePanel',
                  itemId : 'treePanel',
                  flex : 1,
                  qdesk : {
                    schedulerType : config.qdesk.schedulerType
                  }
                }
              ]
            }
          ],

          buttons : [
            {
              itemId : 'closeButton',
              text : QDesk.Msg.get( 'QDesk.buttonLabelClose' )
            }
          ]
        }
    );

    me.callParent( [ config ] );
  }
} );
