/*
 * Copyright (c) 2013-2018 QuartzDesk.com. All Rights Reserved.
 * QuartzDesk.com PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

Ext.define( 'QDesk.view.work.scheduler.common.notif.exec.ExecNotificationRuleMessageMacrosWindow', {
  extend : 'Ext.window.Window',

  requires : [
    'QDesk.Msg',
    'QDesk.model.scheduler.SchedulerType',
    'QDesk.view.work.scheduler.common.notif.exec.ExecNotificationRuleMessageMacrosForm'
  ],

  alias : 'widget.ExecNotificationRuleMessageMacrosWindow',

  cls : 'execNotificationRuleMessageMacrosWindow',
  iconCls : 'windowIcon',

  modal : true,
  resizable : true,

  //scrollable : false,

  width : 800,
  height : 500,

  layout : 'fit',

  qdesk : {
    /*
     * Scheduler type (see QDesk.model.scheduler.SchedulerType).
     */
    schedulerType : undefined
  },

  constructor : function ( config )
  {
    var me = this;

    config = config || {};

    if ( !config.qdesk )
      Ext.Error.raise( 'Required config parameter missing: qdesk' );

    if ( !config.qdesk.schedulerType )
      Ext.Error.raise( 'Required config parameter missing: qdesk.schedulerType' );

    Ext.apply( config, {
      title : QDesk.Msg.get(
          'QDesk.view.work.scheduler.common.notif.exec.ExecNotificationRuleMessageMacrosWindow.windowTitle' ),
      items : [
        {
          xtype : 'ExecNotificationRuleMessageMacrosForm',
          itemId : 'form',
          qdesk : {
            schedulerType : config.qdesk.schedulerType
          }
        }
      ]
    } );

    me.callParent( [ config ] );

    me._bindEventHandlers();
  },


  /**
   * Binds event handlers to all form widgets.
   */
  _bindEventHandlers : function ()
  {
    var me = this;

    me.down( '#closeButton' ).on( 'click', function ()
    {
      me.close();
    } );

    me.down( '#treePanel' ).on( 'itemdblclick',
        function ( treePanel, record, item, index, event )
        {
          var leaf = record.get( 'leaf' );
          if ( leaf )
          {
            var macroName = record.get( 'macroName' );
            me.fireEvent( 'macroSelected', '${' + macroName + '}' );
            me.close();
          }
        }, me );
  }
} );
