/*
 * Copyright (c) 2013-2018 QuartzDesk.com. All Rights Reserved.
 * QuartzDesk.com PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

Ext.define( 'QDesk.view.work.scheduler.quartz.JobDataMapWindow', {
  extend : 'Ext.window.Window',

  requires : [
    'QDesk.Msg',
    'QDesk.view.work.scheduler.quartz.JobDataMapGrid'
  ],

  alias : 'widget.QuartzJobDataMapWindow',

  cls : 'quartzJobDataMapWindow',
  iconCls : 'windowIcon',

  scrollable : true,

  modal : true,
  resizable : true,

  width : 500,

  minWidth : 300,
  minHeight : 320,

  layout : 'fit',

  bodyCls : 'formLikeBody',

  constructor : function ( config )
  {
    var me = this;

    config = config || {};

    // assert config.qdesk != null

    Ext.apply( config, {
      items : [
        {
          xtype : 'panel',
          layout : {
            type : 'vbox',
            align : 'stretch'
          },
          border : false,
          items : [
            {
              xtype : 'QuartzJobDataMapGrid',
              itemId : 'jobDataMapGrid',
              flex : 1,

              qdesk : {
                editable : false, /* grid should not be editable */
                jobDataMap : config.qdesk.jobDataMap,
                mergedJobDataMap : config.qdesk.mergedJobDataMap
              }
            },
            {
              xtype : 'checkboxfield',
              itemId : 'viewMergedJobDataMapCheckbox',
              name : 'viewMergedJobDataMapCheckbox',
              boxLabel : QDesk.Msg.get(
                  'QDesk.view.work.scheduler.quartz.JobDataMapForm.boxLabelViewMergedJobDataMapCheckbox' ),
              boxTooltip : QDesk.Msg.get(
                  'QDesk.view.work.scheduler.quartz.JobDataMapForm.boxTooltipViewMergedJobDataMapCheckbox' ),
              hidden : config.qdesk.mergedJobDataMap == null,
              style : {
                marginLeft : '5px !important'
              }
            }
          ]
        }
      ],

      dockedItems : [
        {
          xtype : 'toolbar',
          dock : 'bottom',
          ui : 'footer',
          defaults : {
            minWidth : 75
          },
          items : [
            {
              xtype : 'component',
              flex : 1
            },
            {
              xtype : 'button',
              itemId : 'closeButton',
              text : QDesk.Msg.get( 'QDesk.buttonLabelClose' )
            }
          ]
        }
      ]
    } );

    me.callParent( [ config ] );
  }
} );