/*
 * Copyright (c) 2013-2018 QuartzDesk.com. All Rights Reserved.
 * QuartzDesk.com PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

Ext.define( 'QDesk.view.work.scheduler.quartz.ListenersGrid', {
  extend : 'Ext.grid.Panel',

  alias : 'widget.QuartzListenersGrid',

  cls : 'quartzListenersGrid',
  //iconCls : 'quartzListenersGridIcon',

  initComponent : function ()
  {
    var me = this;

    var columns = [];

    if ( me.qdesk.visibleNameColumn )
    {
      columns.push( {
        text : QDesk.Msg.get( 'QDesk.view.work.scheduler.quartz.ListenersGrid.textNameColumn' ),
        flex : 1,
        hideable : false,
        sortable : false,
        dataIndex : 'name'
      } );
    }

    columns.push( {
      text : QDesk.Msg.get( 'QDesk.view.work.scheduler.quartz.ListenersGrid.textClassNameColumn' ),
      flex : 2,
      hideable : false,
      sortable : false,
      dataIndex : 'className'
    } );

    Ext.apply( this, {
      columns : columns
    } );

    me.callParent();
  },


  constructor : function ( config )
  {
    var me = this;

    config = config || {};

    var qdesk = config.qdesk || {};

    var store = null;
    if ( qdesk.visibleNameColumn )
    {
      store = Ext.create( 'Ext.data.Store', {
        fields : [ 'name', 'className' ],
        data : []
      } );

    }
    else
    {
      store = Ext.create( 'Ext.data.Store', {
        fields : [ 'className' ],
        data : []
      } );
    }

    Ext.apply( config, {
      store : store
    } );

    me.callParent( [ config ] );
  }
} )
;