/*
 * Copyright (c) 2013-2018 QuartzDesk.com. All Rights Reserved.
 * QuartzDesk.com PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

Ext.define( 'QDesk.view.work.scheduler.quartz.info.ConnectionInfoView', {
  extend : 'QDesk.view.work.scheduler.BaseSchedulerSubTab',

  requires : [
    'QDesk.Msg',
    'QDesk.view.work.scheduler.quartz.info.ConnectionInfoForm'
  ],

  alias : 'widget.QuartzConnectionInfoView',

  border : false,

  iconCls : 'quartzConnectionInfoViewIcon',

  layout : 'fit',

  items : [
    {
      xtype : 'QuartzConnectionInfoForm',
      itemId : 'connectionInfoForm'
    }
  ],


  constructor : function ( config )
  {
    var me = this;

    config = config || {};

    if ( !config.qdesk )
      Ext.Error.raise( 'Required config parameter missing: qdesk' );

    if ( !config.qdesk.connectionId )
      Ext.Error.raise( 'Required config parameter missing: qdesk.connectionId' );

    if ( !config.qdesk.schedulerInfo )
      Ext.Error.raise( 'Required config parameter missing: qdesk.schedulerInfo' );

    if ( !config.qdesk.jvmAgentInfo )
      Ext.Error.raise( 'Required config parameter missing: qdesk.jvmAgentInfo' );

    Ext.apply( config, {
      title : QDesk.Msg.get( 'QDesk.view.work.scheduler.quartz.info.ConnectionInfoView.title' ),
      tooltip : QDesk.Msg.get( 'QDesk.view.work.scheduler.quartz.info.ConnectionInfoView.tooltip' )
    } );

    me.callParent( [ config ] );
  }
} );