/*
 * Copyright (c) 2013-2018 QuartzDesk.com. All Rights Reserved.
 * QuartzDesk.com PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

Ext.define( 'QDesk.view.work.scheduler.quartz.jobs.JobsTabViews', {
  extend : 'QDesk.view.widget.tab.XTabPanel',

  requires : [
    'QDesk.view.work.scheduler.quartz.jobs.audit.JobAuditTrailView',
    'QDesk.view.work.scheduler.quartz.jobs.chain.JobJobChainsView',
    'QDesk.view.work.scheduler.quartz.jobs.history.JobExecHistoryView',
    'QDesk.view.work.scheduler.quartz.jobs.misfire.JobMisfiredTriggersView',
    'QDesk.view.work.scheduler.quartz.jobs.notif.exec.JobExecNotificationsView',
    'QDesk.view.work.scheduler.quartz.jobs.stats.JobStatisticsView',
    'QDesk.view.work.scheduler.quartz.jobs.triggers.JobTriggersView'
  ],

  alias : 'widget.QuartzJobsTabViews',

  cls : 'quartzJobsTabViews',
  bodyCls : 'quartzJobsTabViewsBody',

  constructor : function ( config )
  {
    var me = this;

    config = config || {};

    if ( !config.qdesk )
      Ext.Error.raise( 'Required config parameter missing: qdesk' );

    if ( !config.qdesk.connectionId )
      Ext.Error.raise( 'Required config parameter missing: qdesk.connectionId' );

    if ( !config.qdesk.schedulerInfo )
      Ext.Error.raise( 'Required config parameter missing: qdesk.schedulerInfo' );

    if ( !config.qdesk.jvmAgentInfo )
      Ext.Error.raise( 'Required config parameter missing: qdesk.jvmAgentInfo' );

    Ext.apply( config, {
      items : [
        // Execution History - selected job's execution history
        {
          xtype : 'QuartzJobExecHistoryView',
          itemId : 'historyView',
          qdesk : config.qdesk
        },

        // Triggers - selected job's triggers
        {
          xtype : 'QuartzJobTriggersView',
          itemId : 'triggersView',
          qdesk : config.qdesk
        },

        // Misfired Triggers - selected job's misfired triggers
        {
          xtype : 'QuartzJobMisfiredTriggersView',
          itemId : 'misfiredTriggersView',
          qdesk : config.qdesk
        },

        // Statistics - selected job's execution statistics
        {
          xtype : 'QuartzJobStatisticsView',
          itemId : 'statisticsView',
          qdesk : config.qdesk
        },

        // Execution Notification Rules - selected job's execution notification rules
        {
          xtype : 'QuartzJobExecNotificationsView',
          itemId : 'notificationsView',
          qdesk : config.qdesk
        },

        // Job Chains - selected job's job chains
        {
          xtype : 'QuartzJobJobChainsView',
          itemId : 'jobChainsView',
          qdesk : config.qdesk
        },

        // Audit Trail - selected job's audit trail
        {
          xtype : 'QuartzJobAuditTrailView',
          itemId : 'auditTrailView',
          qdesk : config.qdesk
        }
      ]
    } );

    me.callParent( [ config ] );
  }
} );
