/*
 * Copyright (c) 2013-2018 QuartzDesk.com. All Rights Reserved.
 * QuartzDesk.com PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

Ext.define( 'QDesk.view.work.scheduler.quartz.triggers.TriggersTabViews', {
  extend : 'QDesk.view.widget.tab.XTabPanel',

  requires : [
    'QDesk.view.work.scheduler.quartz.triggers.audit.TriggerAuditTrailView',
    'QDesk.view.work.scheduler.quartz.triggers.chain.TriggerJobChainsView',
    'QDesk.view.work.scheduler.quartz.triggers.history.TriggerExecHistoryView',
    'QDesk.view.work.scheduler.quartz.triggers.misfire.TriggerMisfiredTriggersView',
    'QDesk.view.work.scheduler.quartz.triggers.notif.exec.TriggerExecNotificationsView',
    'QDesk.view.work.scheduler.quartz.triggers.stats.TriggerStatisticsView'
  ],

  alias : 'widget.QuartzTriggersTabViews',

  cls : 'quartzTriggersTabViews',
  bodyCls : 'quartzTriggersTabViewsBody',

  constructor : function ( config )
  {
    var me = this;

    config = config || {};

    if ( !config.qdesk )
      Ext.Error.raise( 'Required config parameter missing: qdesk' );

    if ( !config.qdesk.connectionId )
      Ext.Error.raise( 'Required config parameter missing: qdesk.connectionId' );

    if ( !config.qdesk.schedulerInfo )
      Ext.Error.raise( 'Required config parameter missing: qdesk.schedulerInfo' );

    if ( !config.qdesk.jvmAgentInfo )
      Ext.Error.raise( 'Required config parameter missing: qdesk.jvmAgentInfo' );

    Ext.apply( config, {
      items : [
        // Execution History - selected trigger's execution history
        {
          xtype : 'QuartzTriggerExecHistoryView',
          itemId : 'historyView',
          qdesk : config.qdesk
        },

        // Misfired Triggers - selected trigger's misfired trigger records.
        {
          xtype : 'QuartzTriggerMisfiredTriggersView',
          itemId : 'misfiredTriggersView',
          qdesk : config.qdesk
        },

        // Statistics - selected job's execution statistics
        {
          xtype : 'QuartzTriggerStatisticsView',
          itemId : 'statisticsView',
          qdesk : config.qdesk
        },

        // Execution Notification Rules - selected trigger's execution notification rules
        {
          xtype : 'QuartzTriggerExecNotificationsView',
          itemId : 'notificationsView',
          qdesk : config.qdesk
        },

        // Job Chains - selected trigger's job chains
        {
          xtype : 'QuartzTriggerJobChainsView',
          itemId : 'jobChainsView',
          qdesk : config.qdesk
        },

        // Audit Trail - selected trigger's audit trail
        {
          xtype : 'QuartzTriggerAuditTrailView',
          itemId : 'auditTrailView',
          qdesk : config.qdesk
        }
      ]
    } );

    me.callParent( [ config ] );
  }
} );
